
PROGRAM YAHTZEE;

(* VERSION 3.00

   DATE DE CREATION :     24-12-1998.
   DERNIERE MISE A JOUR : 09-03-1999.

   JEU DE TRIPLE YAHTZEE A PLUSIEURS JOUEURS SUR LE MEME POSTE.

   CHAQUE JOUEUR SE VOIT DOTE D'UNE FENETRE MDI. *)

Uses STRINGS, WINTYPES, WINPROCS, WINDOS, OWINDOWS, ODIALOGS;

{$R YAHTZEE.RES}   (* CHARGEMENT DES RESSOURCES *)

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                               CONSTANTES NON TYPEES                                                  *)
(* -------------------------------------------------------------------------------------------------------------------- *)

{$I YAHTZEE.INC}

Const (* CODES INDIQUANT L'ACTION EN COURS *)
      ac_Aucune = 0;        (* AUCUNE ACTION EN COURS *)
      ac_ChoixDes = 1;      (* SELECTION DES DES *)
      ac_Inscription = 2;   (* INSCRIPTION DANS LA FEUILLE DE POINTS *)
      ac_Commande = 3;      (* APRES INSCRIPTION DES POINTS, CHOIX D'UNE COMMANDE *)

      (* SORTES DE TRICHERIES *)
      trich_Aucune = 0;    (* AUCUNE TRICHERIE *)
      trich_Yahtzee = 1;   (* FORCER UN YAHTZEE *)
      trich_GSuite = 2;    (* FORCER UNE GRANDE SUITE *)

      (* CONSTANTES DIVERSES *)
      NbClas = 100;   (* NOMBRE D'ELEMENTS DES TABLEAUX DE CLASSEMENT *)

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                                  TYPES PREDEFINIS                                                    *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Type (* CHAINES DE CARACTERES *)
     Str40 = Array [0..40] of Char;

     (* APPLICATION *)
     tProgramme = Object(tApplication)
                    Constructor INIT (NomProgramme : pChar);
                       (* REMPLACEMENT DE LA ROUTINE DE GESTION DES ALLOCATIONS DYNAMIQUES *)
                    Procedure INITINSTANCE; virtual;
                       (* CHARGEMENT DE LA TABLE D'ACCELERATEURS *)
                    Procedure INITMAINWINDOW; virtual;
                       (* CHOIX DE LA FENETRE PRINCIPALE DE L'APPLICATION *)
                  end;

     (* DIALOGUE DE DEMARRAGE *)
     pDlgDemarrage = ^tDlgDemarrage;
     tDlgDemarrage = Object(tDialog)
                       Procedure SETUPWINDOW; virtual;
                          (* CENTRAGE DU DIALOGUE A L'ECRAN *)
                       Procedure DEBUT;
                          (* AFFICHAGE DU DIALOGUE *)
                       Procedure FIN;
                          (* DESTRUCTION DU DIALOGUE *)
                     end;

     (* FENETRE PRINCIPALE *)
     pFenetrePrincipale = ^tFenetrePrincipale;
     tFenetrePrincipale = Object(tMDIWindow)
                            DialogueDemarrage : pDlgDemarrage;   (* PETIT DIALOGUE DE DEMARRAGE *)
                            Constructor INIT (TitreFenetre : pChar; MenuPrincipal : hMenu);
                               (* CONSTRUCTION ET INITIALISATION DE LA FENETRE *)
                            Procedure GETWINDOWCLASS (var aWndClass : tWndClass); virtual;
                               (* DEFINITION DE L'ICONE DE CLASSE DU PROGRAMME *)
                            Procedure MESSAGE_ERREUR_MEMOIRE;
                               (* MESSAGE D'ERREUR FATALE D'ALLOCATION DE MEMOIRE *)
                            Procedure SETUPWINDOW; virtual;
                               (* INITIALISATION DES VARIABLES GLOBALES *)
                            Procedure WMCOMMAND (var Msg : tMessage); virtual wm_First + wm_Command;
                               (* REPONSE AUX COMMANDES DE CHOIX DES COULEURS *)
                            Procedure NOUVELLE_PARTIE (var Msg : tMessage); virtual cm_First + cm_NouvellePartie;
                               (* GESTION COMPLETE D'UNE PARTIE *)
                            Procedure CMSCORES (var Msg : tMessage); virtual cm_First + cm_Scores;
                               (* AFFICHAGE DES SCORES ACTUELS DE TOUS LES JOUEURS *)
                            Procedure CMENREGISTRER (var Msg : tMessage); virtual cm_First + cm_Enregistrer;
                               (* MISE A JOUR DES FICHIERS DE CLASSEMENT DES JOUEURS *)
                            Procedure CMCLASSEMENT (var Msg : tMessage); virtual cm_First + cm_Classement;
                               (* AFFICHAGE DES CLASSEMENTS *)
                            Procedure CMQUITTER (var Msg : tMessage); virtual cm_First + cm_Quitter;
                               (* QUITTER LE JEU *)
                            Procedure CMPLEINEFENETRE (var Msg : tMessage); virtual cm_First + cm_PleineFenetre;
                               (* AGRANDISSEMENT DES FENETRES DE JEU EN PLEIN ECRAN *)
                            Procedure CMOPTIONSTRI (var Msg : tMessage); virtual cm_First + cm_OptionsTri;
                               (* OPTION DE TRI DES DES : COCHAGE CORRESPONDANT DU MENU *)
                            Procedure COULEUR_SELECTION (n : Word);
                               (* SELECTION DE LA COULEUR DES DES SELECTIONNES ET COCHAGE DU MENU CORRESPONDANT *)
                            Procedure CMCONVERSION (var Msg : tMessage); virtual cm_First + cm_Conversion;
                               (* CONVERSION D'UN CLASSEMENT DE LA VERSION 2.xx VERS LA VERSION 3.00 *)
                            Procedure CMFUSION (var Msg : tMessage); virtual cm_First + cm_Fusion;
                               (* FUSION DE DEUX CLASSEMENTS EN UN SEUL *)
                            Procedure CMAIDE (var Msg : tMessage); virtual cm_First + cm_Aide;
                               (* ACCES A L'AIDE *)
                            Procedure CMAPROPOS (var Msg : tMessage); virtual cm_First + cm_APropos;
                               (* AFFICHAGE DU DIALOGUE "A PROPOS DE" *)
                            Function CANCLOSE : Boolean; virtual;
                               (* FIN DE PROGRAMME APRES CONFIRMATION *)
                            Destructor DONE; virtual;
                               (* DESALLOCATION DES OBJETS ET DES VARIABLES DYNAMIQUES ET SORTIE DU PROGRAMME *)
                          end;

     (* TABLEAU D'ADRESSES DES BOUTONS DE CHOIX DES DES *)
     tTabBoutonsDes = Array [1..5] of pButton;

     (* FENETRE DE JEU DE CHAQUE JOUEUR *)
     pFenetreJeu = ^tFenetreJeu;
     tFenetreJeu = Object(tWindow)
                     IndexJoueur : Byte;   (* INDICE DANS LE TABLEAU DES JOUEURS *)
                     TabBoutonsDes : tTabBoutonsDes;   (* ADRESSES DES BOUTONS DE CHOIX DES DES *)
                     BoutonCmd1, BoutonCmd2 : pButton;   (* ADRESSEs DES DEUX PREMIERS BOUTONS DE COMMANDE *)
                     Constructor INIT (FenetreParent : pWindowsObject; Titre : pChar; Index : Byte);
                        (* DEFINITION DU STYLE DE LA FENETRE - CREATION DES CONTROLES ENFANTS *)
                     Procedure GETWINDOWCLASS (var aWndClass : tWndClass); virtual;
                        (* DEFINITION DE L'ICONE DE FENETRE DE JEU *)
                     Procedure SETUPWINDOW; virtual;
                        (* INITIALISATION DES DES ET DE LA FEUILLE DE POINTS *)
                     Procedure PAINT (PaintDC : hDC; var PaintInfo : tPaintStruct); virtual;
                        (* DESSIN DU CONTENU DE LA FENETRE *)
                     Procedure AFFICHAGE_POINTS;
                        (* AFFICHAGE DES POINTS DANS LA FEUILLE DE POINTS *)
                     Procedure DESSIN_DE (n : Byte);
                        (* DESSINE UN DE - SA COULEUR INDIQUE S'IL EST SELECTIONNE OU PAS *)
                     Procedure CONTOUR_BOUTON_DE (n : Byte);
                        (* DESSINE OU EFFACE LE CONTOUR AUTOUR D'UN BOUTON DE CHOIX DE DE *)
                     Procedure CONTOUR_CASE_FEUILLE (l, c : Byte; Surbriller : Boolean);
                        (* DESSINE OU EFFACE LE CONTOUR D'UNE CASE DE LA FEUILLE DE POINTS *)
                     Procedure CONTOUR_BOUTON_COMMANDE (n : Byte);
                        (* DESSINE OU EFFACE LE CONTOUR AUTOUR D'UN BOUTON DE COMMANDE *)
                     Procedure AFFICHAGE_NOMBRE_LANCERS;
                        (* AFFICHAGE DU NOMBRE DE LANCERS RESTANTS *)
                     Procedure ACTIVATION_BOUTON_DE (n : Byte);
                        (* REACTION A L'ACTIVATION D'UN BOUTON DE CHOIX DES DES *)
                     Procedure TRI_DES;
                        (* TRI DES CINQ DES PAR ORDRE CROISSANT *)
                     Procedure PREPARATION_PREMIER_LANCER_DES;
                        (* PREPARATION DU 1ER LANCER DE DES DU COUP COURANT *)
                     Procedure LANCER_DES (Tricher : Byte);
                        (* LANCER DES DES NON SELECTIONNES AVEC TRICHERIE EVENTUELLE *)
                     Procedure FIN_LANCER_DES;
                        (* FIN DES LANCERS DE DES ET ACCES A LA FEUILLE DE POINTS *)
                     Procedure INSCRIPTION (l, c : Byte);
                        (* INSCRIPTION DES POINTS DANS LA FEUILLE DE POINTS *)
                     Procedure FIN_INSCRIPTION;
                        (* FIN DE L'INSCRIPTION SUR LA FEUILLE DE POINTS ET ACCES AUX BOUTONS DE COMMANDE *)
                     Function TEST_YAHTZEE : Boolean;
                        (* TESTE SI LES CINQ DES FORMENT UN YAHTZEE *)
                     Function TEST_BRELAN : Boolean;
                        (* TESTE SI LES CINQ DES FORMENT UN BRELAN *)
                     Function TEST_CARRE : Boolean;
                        (* TESTE SI LES CINQ DES FORMENT UN CARRE *)
                     Function TEST_FULL : Boolean;
                        (* TESTE SI LES CINQ DES FORMENT UN FULL *)
                     Function TEST_PSUITE : Boolean;
                        (* TESTE SI LES CINQ DES FORMENT UNE PETITE SUITE *)
                     Function TEST_GSUITE : Boolean;
                        (* TESTE SI LES CINQ DES FORMENT UNE GRANDE SUITE *)
                     Function TEST_YAHTZEE_SUP : Boolean;
                        (* TESTE SI LES CINQ DES FORMENT UN YAHTZEE ET S'IL S'AGIT D'UN YAHTZEE SUPPLEMENTAIRE *)
                     Procedure IDBOUTONDE1 (var Msg : tMessage); virtual id_First + id_BoutonDe1;
                        (* BOUTON DE SELECTION DU 1ER DE *)
                     Procedure IDBOUTONDE2 (var Msg : tMessage); virtual id_First + id_BoutonDe2;
                        (* BOUTON DE SELECTION DU 2EME DE *)
                     Procedure IDBOUTONDE3 (var Msg : tMessage); virtual id_First + id_BoutonDe3;
                        (* BOUTON DE SELECTION DU 3EME DE *)
                     Procedure IDBOUTONDE4 (var Msg : tMessage); virtual id_First + id_BoutonDe4;
                        (* BOUTON DE SELECTION DU 4EME DE *)
                     Procedure IDBOUTONDE5 (var Msg : tMessage); virtual id_First + id_BoutonDe5;
                        (* BOUTON DE SELECTION DU 5EME DE *)
                     Procedure CMFLECHEHAUT (var Msg : tMessage); virtual cm_First + cm_FlecheHaut;
                        (* REPONSE A L'ACTIVATION DE LA FLECHE VERS LE HAUT *)
                     Procedure CMFLECHEBAS (var Msg : tMessage); virtual cm_First + cm_FlecheBas;
                        (* REPONSE A L'ACTIVATION DE LA FLECHE VERS LE BAS *)
                     Procedure CMFLECHEGAUCHE (var Msg : tMessage); virtual cm_First + cm_FlecheGauche;
                        (* REPONSE A L'ACTIVATION DE LA FLECHE VERS LA GAUCHE *)
                     Procedure CMFLECHEDROITE (var Msg : tMessage); virtual cm_First + cm_FlecheDroite;
                        (* REPONSE A L'ACTIVATION DE LA FLECHE VERS LA DROITE *)
                     Procedure CMENTER (var Msg : tMessage); virtual cm_First + cm_Enter;
                        (* REPONSE A L'ACTIVATION DE LA TOUCHE ENTER *)
                     Procedure CMESCAPE (var Msg : tMessage); virtual cm_First + cm_Escape;
                        (* REPONSE A L'ACTIVATION DE LA TOUCHE ESCAPE *)
                     Procedure CMTRICHERYAHTZEE (var Msg : tMessage); virtual cm_First + cm_Tricheryahtzee;
                        (* REPONSE A L'ACTIVATION DE LA TOUCHE FORCANT LE TIRAGE D'UN YAHTZEE *)
                     Procedure WMLBUTTONDOWN (var Msg : tMessage); virtual wm_First + wm_LButtonDown;
                        (* CLIC DU BOUTON GAUCHE DE LA SOURIS *)
                     Function JOUEUR_SUIVANT : Byte;
                        (* RETOURNE L'INDICE DU JOUEUR SUIVANT (0 S'IL N'Y EN A PLUS) *)
                     Procedure IDBOUTONCMD1 (var Msg : tMessage); virtual id_First + id_BoutonCmd1;
                        (* REPONSE A L'ACTIVATION DU BOUTON DE COMMANDE "LANCER LES DES" / "JOUEUR SUIVANT" *)
                     Procedure IDBOUTONCMD2 (var Msg : tMessage); virtual id_First + id_BoutonCmd2;
                        (* REPONSE A L'ACTIVATION DU BOUTON DE COMMANDE "CORRIGER LES POINTS" *)
                     Procedure WMSYSCOMMAND (var Msg : tMessage); virtual wm_First + wm_SysCommand;
                        (* INTERCEPTION DE TOUTES LES COMMANDES SYSTEME *)
                     Destructor DONE; virtual;
                        (* ANNULATION DE L'ADRESSE DE LA FENETRE DANS LA LISTE DES JOUEURS *)
                   end;

     (* DIALOGUE DE DEFINITION DES NOMS DES JOUEURS *)
     pDlgNomsJoueurs = ^tDlgNomsJoueurs;
     tDlgNomsJoueurs = Object(tDialog)
                         Procedure SETUPWINDOW; virtual;
                            (* INITIALISATION DES CONTROLES ENFANTS *)
                         Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                            (* BOUTON "OK" : LES NOMS DES JOUEURS SONT CHARGES DANS LE TABLEAU *)
                         Procedure HELP (var Msg : tMessage); virtual id_First + id_Help;
                            (* BOUTON "AIDE" *)
                         Procedure CANCEL (var Msg : tMessage); virtual id_First + id_Cancel;
                            (* BOUTON "QUITTER" : FIN DU JEU (TABLEAU DES JOUEURS VIDE) *)
                       end;

     (* DIALOGUE D'AFFICHAGE DES RESULTATS *)
     pDlgResultats = ^tDlgResultats;
     tDlgResultats = Object(tDialog)
                       Procedure SETUPWINDOW; virtual;
                          (* INITIALISATION DES CONTROLES ENFANTS *)
                     end;

     (* DIALOGUE D'AFFICHAGE DES CLASSEMENTS SANS ET AVEC PRIMES YAHTZEE *)
     pDlgClassements = ^tDlgClassements;
     tDlgClassements = Object(tDialog)
                         Procedure SETUPWINDOW; virtual;
                            (* INITIALISATION DES DEUX LISTES DE CLASSEMENT *)
                       end;

     (* DIALOGUE DE FUSION DE CLASSEMENTS *)
     pDlgFusion = ^tDlgFusion;
     tDlgFusion = Object(tDialog)
                    Procedure SETUPWINDOW; virtual;
                       (* INITIALISATION DES CONTROLES ENFANTS *)
                    Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                       (* BOUTON "OK" : CHARGEMENT DES NOMS DE FICHIERS *)
                    Procedure HELP (var Msg : tMessage); virtual id_First + id_Help;
                       (* BOUTON "AIDE" *)
                  end;

     (* DIALOGUE DE CONVERSION DES CLASSEMENTS DE LA VERSION 2.xx VERS LA VERSION 3.00 *)
     pDlgConversion = ^tDlgConversion;
     tDlgConversion = Object(tDialog)
                        Procedure SETUPWINDOW; virtual;
                           (* INITIALISATION DES CONTROLES ENFANTS *)
                        Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                           (* BOUTON "OK" : CHARGEMENT DES NOMS DE FICHIERS *)
                        Procedure HELP (var Msg : tMessage); virtual id_First + id_Help;
                           (* BOUTON "AIDE" *)
                      end;

     (* DIALOGUE "A PROPOS DE..." *)
     pDlgAPropos = ^tDlgAPropos;
     tDlgAPropos = Object(tDialog)
                     Procedure SETUPWINDOW; virtual;
                        (* CENTRAGE DU DIALOGUE A L'ECRAN *)
                   end;

     (* COULEURS DES DES SELECTIONNES *)
     tTabCouleurs = Array [1..8] of tColorRef;

     (* FEUILLES DE POINTS *)
     tFeuillePoints = Array [1..19,1..3] of Word;

     (* PARAMETRES GENERAUX DU PROGRAMME *)
     pParam = ^tParam;
     tParam = Record
                HandleMenu : hMenu;                                 (* HANDLE DU MENU PRINCIPAL *)
                HauteResolution : Boolean;                          (* INDIQUE SI LA RESOLUTION ATTEINT 800*600 *)
                wFenetreJeu, hFenetreJeu : Integer;                 (* TAILLE DE LA FENETRE DE JEU *)
                xLogo, yLogo, wLogo, hLogo : Integer;               (* POSITION ET TAILLE DU LOGO *)
                xFeuille, yFeuille, wFeuille, hFeuille : Integer;   (* POSITION ET TAILLE DE LA FEUILLE DE POINTS *)
                RectangleFeuille : tRect;                           (* RECTANGLE DE LA FEUILLE DE POINTS A REDESSINER *)
                xDe, yDe, wDe, hDe : Integer;                       (* POSITION DU 1ER DE ET TAILLE DES DES *)
                dDe : Integer;                                      (* INTERVALLE VERTICAL ENTRE DEUX DES *)
                lPt : Integer;                                      (* RAYON D'UN POINT DESSINE SUR UN DE *)
                wBoutonsDes, hBoutonsDes : Integer;                 (* TAILLE DES BOUTONS DE CHOIX DES DES *)
                xBoutonCmd, yBoutonCmd : Integer;                   (* COORDONNEES DU 1ER BOUTON DE COMMANDE *)
                wBoutonCmd, hBoutonCmd : Integer;                   (* TAILLE DES BOUTONS DE COMMANDE *)
                x1C, y1C, x2C, y2C : Integer;                       (* COORDONNEES EXTREMES DU 1ER BOUTON DE COMMANDE *)
                dBoutonCmd : Integer;                               (* INTERVALLE VERTICAL ENTRE DEUX BOUTONS DE COMMANDE *)
                hImageLogo, hImageFeuille : hBitmap;                (* HANDLES DES BITMAPS (LOGO ET FEUILLE DE POINTS) *)
                RectSectionSup, RectSectionInf : tRect;             (* RECTANGLES DES SECTIONS DE LA FEUILLE DE POINTS *)
                PremiereLigneInf : Byte;                            (* INDICE DE LA 1ERE LIGNE DE LA SECTION INFERIEURE *)
                TabCouleurs : tTabCouleurs;                         (* COULEURS DES DES SELECTIONNES *)
                CouleurSelection : Byte;                            (* INDICE DE LA COULEUR D'UN DE SELECTIONNE *)
                ActionCourante : Byte;                              (* CODE INDIQUANT L'ACTION EN COURS *)
                DeCourant : Byte;                                   (* N DU DE ACTUELLEMENT SURBRILLE *)
                Ligne, Colonne : Byte;                              (* CASE COURANTE DE LA FEUILLE DE POINTS *)
                BoutonCommande : Byte;                              (* BOUTON DE COMMANDE COURANT *)
                NbLancers : Byte;                                   (* NOMBRE DE LANCERS RESTANTS *)
                FeuillePointsSauve : tFeuillePoints;                (* COPIE DE LA FEUILLE DE POINTS (POUR LA CORRECTION) *)
                NomFichierCourant : Array [0..255] of Char;         (* NOM DU FICHIER COURANT *)
                HandleFichier : Integer;                            (* HANDLE DU FICHIER COURANT *)
                Source1, Dest1 : Array [0..255] of Char;            (* NOMS DES FICHIERS SANS PRIMES (FUSION) *)
                Source2, Dest2 : Array [0..255] of Char;            (* NOMS DES FICHIERS AVEC PRIMES (FUSION) *)
                EviterRedondance : Boolean;                         (* SUPPRIMER LES SCORES IDENTIQUES (FUSION) ? *)
              end;

     (* TABLEAU DES JOUEURS *)
     tJoueur = Record
                 NomJoueur : Array [0..20] of Char;   (* NOM DU JOUEUR *)
                 FenetreMDI : pFenetreJeu;            (* ADRESSE DE LA FENETRE ALLOUEE AU JOUEUR *)
                 CoupsJoues : Byte;                   (* NOMBRE DE COUPS JOUES *)
                 FeuillePoints : tFeuillePoints;      (* FEUILLE DE POINTS *)
               end;
     pTabJoueurs = ^tTabJoueurs;
     tTabJoueurs = Array [1..10] of tJoueur;

     (* TABLEAU DES DES *)
     tDe = Record
             Montant : Byte;                 (* VALEUR ACTUELLE DU DE *)
             Selection : Boolean;            (* INDIQUE SI LE DE EST ACTUELLEMENT SELECTIONNE *)
             x1D, y1D, x2D, y2D : Integer;   (* COORDONNEES DU DE *)
             x1B, y1B, x2B, y2B : Integer;   (* COORDONNEES DU BOUTON DE CHOIX *)
           end;
     pTabDes = ^tTabDes;
     tTabDes = Array [1..5] of tDe;

     (* CLASSEMENT DES JOUEURS *)
     pClassement = ^tClassement;
     tClassement = Array [1..NbClas] of Str40;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                                 CONSTANTES TYPEES                                                    *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Const Parametres : pParam = nil;         (* PARAMETRES GENERAUX DU PROGRAMME *)
      Joueurs : pTabJoueurs = nil;       (* TABLEAU DES JOUEURS *)
      TableauDes : pTabDes = nil;        (* TABLEAU DE DES *)
      Classement1 : pClassement = nil;   (* TABLEAU DE CLASSEMENT SANS PRIMES YAHTZEE *)
      Classement2 : pClassement = nil;   (* TABLEAU DE CLASSEMENT AVEC PRIMES YAHTZEE *)

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                                 VARIABLES GLOBALES                                                   *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Var (* PROGRAMME PRINCIPAL *)
    Programme : tProgramme;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                            FONCTION DE GESTION DU TAS                                                *)
(* -------------------------------------------------------------------------------------------------------------------- *)

{$F+}
Function ERREUR_ALLOCATION (Taille : Word) : Integer;
(* FORCE LES PROCEDURES D'ALLOCATION DE MEMOIRE DYNAMIQUE A RENVOYER nil SI ERREUR *)
Begin
  ERREUR_ALLOCATION:=1;
End;
{$F-}

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                         FONCTIONS DE GESTION DES FICHIERS                                            *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Function CREATION_FICHIER (hFenetre : hWnd) : Boolean;
(* CREATION D'UN FICHIER (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Var Ok : Boolean;                (* RESULTAT DE L'OPERATION *)
    c : Array [0..80] of Char;   (* MESSAGE D'ERREUR *)
Begin
  Ok:=false;
  with Parametres^ do
    begin
      HandleFichier:=_lCreat(NomFichierCourant,0);
      if HandleFichier = -1
         then   (* MESSAGE D'ERREUR *)
           begin
             LoadString(hInstance,er_CreationFichier,c,80);
             MessageBox(hFenetre,c,NomFichierCourant,mb_IconHand or mb_Ok);
           end
         else
           Ok:=true;
    end;
  CREATION_FICHIER:=Ok;
End;

Function OUVERTURE_FICHIER (hFenetre : hWnd) : Boolean;
(* OUVERTURE D'UN FICHIER (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Var Ok : Boolean;                (* RESULTAT DE L'OPERATION *)
    c : Array [0..80] of Char;   (* MESSAGE D'ERREUR *)
Begin
  Ok:=false;
  with Parametres^ do
    begin
      HandleFichier:=_lOpen(NomFichierCourant,of_Read or of_Share_Deny_Read);
      if HandleFichier = -1
         then   (* MESSAGE D'ERREUR *)
           begin
             LoadString(hInstance,er_OuvertureFichier,c,80);
             MessageBox(hFenetre,c,NomFichierCourant,mb_IconHand or mb_Ok);
           end
         else
           Ok:=true;
    end;
  OUVERTURE_FICHIER:=Ok;
End;

Function LECTURE_FICHIER (hFenetre : hWnd; Buffer : pChar; TailleBuffer : Integer) : Boolean;
(* LECTURE D'UN FICHIER (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Var Ok : Boolean;                (* RESULTAT DE L'OPERATION *)
    c : Array [0..80] of Char;   (* MESSAGE D'ERREUR *)
    n : Word;                    (* NOMBRE D'OCTETS LUS *)
Begin
  Ok:=false;
  with Parametres^ do
    begin
      n:=_lRead(HandleFichier,Buffer,TailleBuffer);
      if n = $FFFF
         then   (* MESSAGE D'ERREUR *)
           begin
             LoadString(hInstance,er_LectureFichier,c,80);
             MessageBox(hFenetre,c,NomFichierCourant,mb_IconHand or mb_Ok);
           end
         else
           begin
             if n < TailleBuffer
                then   (* FIN DE FICHIER DETECTEE *)
                  Buffer[0]:=#0;
             Ok:=true;
           end;
    end;
  LECTURE_FICHIER:=Ok;
End;

Function ECRITURE_FICHIER (hFenetre : hWnd; Buffer : pChar; TailleBuffer : Integer) : Boolean;
(* ECRITURE D'UN FICHIER (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Var Ok : Boolean;                (* RESULTAT DE L'OPERATION *)
    c : Array [0..80] of Char;   (* MESSAGE D'ERREUR *)
Begin
  Ok:=false;
  with Parametres^ do
    begin
      if _lWrite(HandleFichier,Buffer,TailleBuffer) < TailleBuffer
         then   (* MESSAGE D'ERREUR *)
           begin
             LoadString(hInstance,er_EcritureFichier,c,80);
             MessageBox(hFenetre,c,NomFichierCourant,mb_IconHand or mb_Ok);
           end
         else
           Ok:=true;
    end;
  ECRITURE_FICHIER:=Ok;
End;

Function FERMETURE_FICHIER (hFenetre : hWnd) : Boolean;
(* FERMETURE D'UN FICHIER (UTILISATION DES FONCTIONS FICHIERS DU KERNEL WINDOWS) *)
Var Ok : Boolean;                (* RESULTAT DE L'OPERATION *)
    c : Array [0..80] of Char;   (* MESSAGE D'ERREUR *)
Begin
  Ok:=false;
  with Parametres^ do
    begin
      if _lClose(HandleFichier) <> 0
         then   (* MESSAGE D'ERREUR *)
           begin
             LoadString(hInstance,er_FermetureFichier,c,80);
             MessageBox(hFenetre,c,NomFichierCourant,mb_IconHand or mb_Ok);
           end
         else
           Ok:=true;
    end;
  FERMETURE_FICHIER:=Ok;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                           METHODES DE L'OBJET tProgramme                                             *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Constructor tProgramme.INIT (NomProgramme : pChar);
(* REMPLACEMENT DE LA ROUTINE DE GESTION DES ALLOCATIONS DYNAMIQUES *)
Begin
  HeapError:=@ERREUR_ALLOCATION;
  tApplication.INIT(NomProgramme);
End;

Procedure tProgramme.INITINSTANCE;
(* CHARGEMENT DE LA TABLE D'ACCELERATEURS *)
Begin
  tApplication.INITINSTANCE;
  hAccTable:=LoadAccelerators(hInstance,'ACCELERATEURS');
End;

Procedure tProgramme.INITMAINWINDOW;
(* CHOIX DE LA FENETRE PRINCIPALE DE L'APPLICATION *)
Begin
  MainWindow:=New(pFenetrePrincipale,INIT('Triple Yahtzee 3.00',LoadMenu(hInstance,'MENU_PRINCIPAL')));
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                         METHODES DE L'OBJET tDlgDemarrage                                            *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgDemarrage.SETUPWINDOW;
(* CENTRAGE DU DIALOGUE A L'ECRAN *)
Var r : tRect;
    Largeur, Hauteur : Integer;
Begin
  tDialog.SETUPWINDOW;
  GetWindowRect(hWindow,r);
  with r do
    begin
      Largeur:=Right-Left;
      Hauteur:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-Largeur) div 2,(GetSystemMetrics(sm_CYScreen)-Hauteur) div 2,
             Largeur,Hauteur,true);
End;

Procedure tDlgDemarrage.DEBUT;
(* AFFICHAGE DU DIALOGUE *)
Begin
  Show(sw_ShowNormal);
End;

Procedure tDlgDemarrage.FIN;
(* FERMETURE DU DIALOGUE *)
Begin
  CloseWindow;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                       METHODES DE L'OBJET tFenetrePrincipale                                         *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Constructor tFenetrePrincipale.INIT (TitreFenetre : pChar; MenuPrincipal : hMenu);
(* CONSTRUCTION DE LA FENETRE, AFFECTATION DE L'INDEX DU MENU "Fentre" *)
Begin
  (* AFFICHAGE DU PETIT DIALOGUE D'ATTENTE AU DEMARRAGE *)
  DialogueDemarrage:=pDlgDemarrage(Application^.MakeWindow(New(pDlgDemarrage,INIT(nil,'DIALOGUE_DEMARRAGE'))));
  DialogueDemarrage^.DEBUT;
  (* CONSTRUCTION DE LA FENETRE PRINCIPALE *)
  tMDIWindow.INIT(TitreFenetre,MenuPrincipal);
  (* AFFECTATION DE L'INDEX DU MENU "Fentre" *)
  ChildMenuPos:=1;
End;

Procedure tFenetrePrincipale.GETWINDOWCLASS (var aWndClass : tWndClass);
(* DEFINITION DE L'ICONE DE CLASSE DU PROGRAMME *)
Begin
  tMDIWindow.GETWINDOWCLASS(aWndClass);
  aWndClass.hIcon:=LoadIcon(hInstance,'ICONE_FENETRE_PRINCIPALE');
End;

Procedure tFenetrePrincipale.MESSAGE_ERREUR_MEMOIRE;
(* MESSAGE D'ERREUR FATALE D'ALLOCATION DE MEMOIRE *)
Var Message, Titre : Array [0..55] of Char;   (* TEXTE ET TITRE DE LA BOITE MESSAGE *)
Begin
  LoadString(hInstance,er_Memoire,Message,SizeOf(Message));
  LoadString(hInstance,st_Initialisation,Titre,SizeOf(Titre));
  MessageBox(hWindow,Message,Titre,mb_Ok or mb_IconHand);
End;

Procedure tFenetrePrincipale.SETUPWINDOW;
(* AFFICHAGE EN PLEIN ECRAN, INITIALISATION DES VARIABLES GLOBALES ET DES PARAMETRES GENERAUX *)
Var Ok : Boolean;   (* INDICATEUR D'ERREUR *)
    i : Byte;       (* INDICE *)
Begin
  tMDIWindow.SETUPWINDOW;
  (* PARAMETRES GENERAUX ET INITIALISATION DES VARIABLES GLOBALES *)
  New(Parametres);
  Ok:=(Parametres <> nil);
  if Ok
     then with Parametres^ do
       begin
         if GetSystemMetrics(sm_CXScreen) >= 800
            then   (* ECRAN HAUTE RESOLUTION *)
              begin
                HauteResolution:=true;
                wFenetreJeu:=800; hFenetreJeu:=600 - GetSystemMetrics(sm_CYCaption);
                xLogo:=427; yLogo:=5; wLogo:=300; hLogo:=60;
                xFeuille:=400; yFeuille:=70; wFeuille:=355; hFeuille:=438;
                xDe:=10; yDe:=yFeuille; wDe:=64; hDe:=64; dDe:=16; lPt:=5;
                wBoutonsDes:=90; hBoutonsDes:=30;
                xBoutonCmd:= 220; yBoutonCmd:=yFeuille; wBoutonCmd:=120; hBoutonCmd:=45; dBoutonCmd:=15;
                hImageFeuille:=LoadBitmap(hInstance,'IMAGE_FEUILLE_POINTS_HR');
                hImageLogo:=LoadBitmap(hInstance,'IMAGE_LOGO');
                with RectSectionInf do
                  begin
                    Left:=xFeuille+194; Top:=yFeuille+233; Right:=xFeuille+353; Bottom:=yFeuille+373;
                  end;
                PremiereLigneInf:=10;
              end
            else   (* ECRAN BASSE RESOLUTION *)
              begin
                HauteResolution:=false;
                wFenetreJeu:=640; hFenetreJeu:=480 - GetSystemMetrics(sm_CYCaption);
                xFeuille:=270; yFeuille:=1; wFeuille:=355; hFeuille:=396;
                xDe:=8; yDe:=30; wDe:=48; hDe:=48; dDe:=10; lPt:=4;
                wBoutonsDes:=90; hBoutonsDes:=30;
                xBoutonCmd:= 170; yBoutonCmd:=yFeuille; wBoutonCmd:=90; hBoutonCmd:=45; dBoutonCmd:=10;
                hImageFeuille:=LoadBitmap(hInstance,'IMAGE_FEUILLE_POINTS');
                hImageLogo:=0;
                with RectSectionInf do
                  begin
                    Left:=xFeuille+194; Top:=yFeuille+191; Right:=xFeuille+353; Bottom:=yFeuille+331;
                  end;
                PremiereLigneInf:=8;
              end;
         x1C:=xBoutonCmd; y1C:=yBoutonCmd; x2C:=X1C+wBoutonCmd; y2C:=y1C+hBoutonCmd;
         with RectSectionSup do
           begin
             Left:=xFeuille+194; Top:=yFeuille+22; Right:=xFeuille+353; Bottom:=yFeuille+142;
           end;
         with RectangleFeuille do
           begin
             Left:=RectSectionSup.Left; Top:=RectSectionSup.Top; Right:=RectSectionSup.Right; Bottom:=RectSectionInf.Bottom;
           end;
         ActionCourante:=ac_ChoixDes;
         DeCourant:=1;
         Ligne:=1; Colonne:=1;
         BoutonCommande:=1;
         HandleMenu:=Attr.Menu;
         TabCouleurs[1]:=RGB(0,255,255);
         TabCouleurs[2]:=RGB(0,192,192);
         TabCouleurs[3]:=RGB(255,255,0);
         TabCouleurs[4]:=RGB(192,192,0);
         TabCouleurs[5]:=RGB(192,0,0);
         TabCouleurs[6]:=RGB(0,255,0);
         TabCouleurs[7]:=RGB(255,0,255);
         TabCouleurs[8]:=RGB(192,192,192);
         CouleurSelection:=1;
         NomFichierCourant[0]:=#0;
         HandleFichier:=-1;
       end
     else   (* ERREUR D'ALLOCATION DES PARAMETRES GENERAUX *)
       MESSAGE_ERREUR_MEMOIRE;
  if Ok then New(Joueurs);
  Ok:=(Joueurs <> nil);
  if Ok
     then
       begin
         for i:=1 to 10 do with Joueurs^[i] do
           begin
             NomJoueur[0]:=#0;
             FenetreMDI:=nil;
           end;
       end
     else   (* ERREUR D'ALLOCATION DU TABLEAU DES JOUEURS *)
       MESSAGE_ERREUR_MEMOIRE;
  if Ok then New(TableauDes);
  Ok:=(TableauDes <> nil);
  if Ok
     then
       begin
         Randomize;   (* MISE EN ROUTE DU GENERATEUR DE NOMBRES ALEATOIRES *)
         for i:=1 to 5 do with TableauDes^[i] do with Parametres^ do
           begin
             x1D:=xDe; y1D:=yDe+(wDe+dDe)*(i-1); x2D:=x1D+wDe; y2D:=y1D+hDe;
             x1B:=(xDe*2)+wDe; y1B:=y1D+(hDe div 2)-(hBoutonsDes div 2);
             x2B:=x1B+wBoutonsDes; y2B:=y1B+hBoutonsDes;
           end;
       end
     else   (* ERREUR D'ALLOCATION DU TABLEAU DES DES *)
       MESSAGE_ERREUR_MEMOIRE;
  if Ok then New(Classement1);
  Ok:=(Classement1 <> nil);
  if not Ok then MESSAGE_ERREUR_MEMOIRE;
  if Ok then New(Classement2);
  Ok:=(Classement2 <> nil);
  if not Ok then MESSAGE_ERREUR_MEMOIRE;
  (* EFFACEMENT DU DIALOGUE DE DEMARRAGE *)
  DialogueDemarrage^.FIN;
  if Ok
     then   (* DEMARRAGE DU JEU *)
       begin
         (* COMMANDE D'AFFICHAGE EN PLEIN ECRAN *)
         PostMessage(hWindow,wm_SysCommand,sc_Maximize,0);
         (* DECLENCHEMENT D'UNE NOUVELLE PARTIE *)
         PostMessage(hWindow,wm_Command,cm_NouvellePartie,0);
       end
     else   (* FERMETURE DE LA FENETRE *)
       CloseWindow;
End;

Procedure tFenetrePrincipale.WMCOMMAND (var Msg : tMessage);
(* REPONSE AUX COMMANDES DE CHOIX DES COULEURS *)
Begin
  case Msg.wParam of
    cm_Couleur1..cm_Couleur8 : COULEUR_SELECTION(Msg.wParam-cm_Couleur1+1);
  else
    tWindow.WMCOMMAND(Msg);
  end;
End;

Procedure tFenetrePrincipale.NOUVELLE_PARTIE (var Msg : tMessage);
(* GESTION COMPLETE D'UNE PARTIE *)
Var i : Byte;   (* INDICE DANS LE TABLEAU DES JOUEURS *)
Begin
  (* SUPPRESSION DES FENETRES DE JEU EVENTUELLES *)
  for i:=1 to 10 do with Joueurs^[i] do if FenetreMDI <> nil then FenetreMDI^.CloseWindow;
  (* DEFINITION DES NOMS DES JOUEURS *)
  Application^.EXECDIALOG(pDlgNomsJoueurs(New(pDlgNomsJoueurs,INIT(@Self,'DIALOGUE_NOMS_JOUEURS'))));
  (* TESTE SI AU MOINS UN NOM DE JOUEUR A ETE ENCODE *)
  if (StrLen(Joueurs^[1].NomJoueur) = 0) and (StrLen(Joueurs^[2].NomJoueur) = 0) and
     (StrLen(Joueurs^[3].NomJoueur) = 0) and (StrLen(Joueurs^[4].NomJoueur) = 0) and
     (StrLen(Joueurs^[5].NomJoueur) = 0) and (StrLen(Joueurs^[6].NomJoueur) = 0) and
     (StrLen(Joueurs^[7].NomJoueur) = 0) and (StrLen(Joueurs^[8].NomJoueur) = 0) and
     (StrLen(Joueurs^[9].NomJoueur) = 0) and (StrLen(Joueurs^[10].NomJoueur) = 0)
     then   (* AUCUN NOM : QUITTER LE PROGRAMME *)
       CloseWindow
     else   (* AU MOINS UN NOM ENCODE : ON PEUT Y ALLER *)
       begin
         (* CREATION DES FENETRES DE TOUS LES JOUEURS (EN ORDRE INVERSE : LE PREMIER AURA DONC LE FOCUS) *)
         for i:=10 downto 1 do with Joueurs^[i] do
           if StrLen(NomJoueur) > 0
              then
                FenetreMDI:=pFenetreJeu(Application^.MAKEWINDOW(New(pFenetreJeu,INIT(@Self,NomJoueur,i))));
       end;
End;

Procedure tFenetrePrincipale.CMENREGISTRER (var Msg : tMessage);
(* AFFICHAGE DES RESULTATS ET MISE A JOUR DES FICHIERS DE CLASSEMENT A LA FIN DE LA PARTIE *)
Const ChaineVierge = '                    '#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0;
Var Ok : Boolean;                         (* INTERRUPTEUR DE BOUCLE *)
    i, j, k, l, n : Byte;                 (* INDICES *)
    Valeur : Word;                        (* CONVERSION DE CHAINE EN NOMBRE *)
    Erreur : Integer;                     (* RESULTAT DE LA CONVERSION *)
    c : Array [0..20] of Char;            (* EXTRAIT D'ELEMENT DE CLASSEMENT *)
    ChaineDate : Array [0..10] of Char;   (* DATE DU JOUR SOUS FORME DE CHAINE *)
    Jour, Mois, Annee : Word;             (* DATE DU JOUR SOUS FORME DE NOMBRES *)
    ChaineClas, s : String [40];          (* CONSTRUCTION DE LA CHAINE DE CLASSEMENT *)
Begin
  (* AFFICHAGE DES RESULTATS *)
  Application^.EXECDIALOG(pDlgResultats(New(pDlgResultats,INIT(@Self,'DIALOGUE_RESULTATS'))));
  (* DETERMINATION DE LA DATE DU JOUR *)
  GetDate(Annee,Mois,Jour,Valeur);
  Str(Jour,s); if Jour < 10 then Insert('0',s,1); StrPCopy(ChaineDate,s+'-');
  Str(Mois,s); if Mois < 10 then Insert('0',s,1); StrPCopy(c,s+'-'); StrCat(ChaineDate,c);
  Str(Annee,s); StrPCopy(c,s); StrCat(ChaineDate,c);
  (* CLASSEMENTS VIERGES *)
  for i:=1 to NbClas do
    begin
      StrCopy(Classement1^[i],ChaineVierge);
      StrCopy(Classement2^[i],ChaineVierge);
    end;
  (* CHARGEMENT DU CLASSEMENT SANS PRIMES *)
  LoadString(hInstance,st_NomFichier1,Parametres^.NomFichierCourant,13);
  if OUVERTURE_FICHIER(hWindow)
     then
       begin
         i:=1; Ok:=true;
         while (i <= NbClas) and Ok do
           begin
             Ok:=LECTURE_FICHIER(hWindow,Classement1^[i],40);
             inc(i);
           end;
         FERMETURE_FICHIER(hWindow);
       end;
  (* MISE A JOUR DU CLASSEMENT SANS PRIMES AVEC LES RESULTATS DE LA PARTIE ACTUELLE *)
  for n:=1 to 10 do with Joueurs^[n] do
    begin
      if StrLen(NomJoueur) > 0
         then
           begin
             i:=1;
             while i <= NbClas do
               begin
                 s:=StrPas(Classement1^[i]);
                 Val(Copy(s,1,5),Valeur,Erreur);
                 if FeuillePoints[19,1] > Valeur
                    then   (* POINT D'INSERTION TROUVE : INSERTION DU RESULTAT DANS LE CLASSEMENT *)
                      begin
                        for j:=NbClas downto (i+1) do Classement1^[j]:=Classement1^[j-1];
                        for k:=1 to 10 do ChaineClas[k]:=' ';
                        Str(FeuillePoints[19,1],s); l:=Length(s); if l < 5 then for k:=1 to (5-l) do Insert(' ',s,1);
                        for k:=1 to 5 do ChaineClas[k]:=s[k];
                        Str(FeuillePoints[19,3],s); l:=Length(s); if l < 5 then for k:=1 to (5-l) do Insert(' ',s,1);
                        for k:=1 to 5 do ChaineClas[k+5]:=s[k];
                        ChaineClas[0]:=#10;
                        StrPCopy(Classement1^[i],ChaineClas);
                        StrCat(Classement1^[i],ChaineDate);
                        StrCat(Classement1^[i],NomJoueur);
                        (* FIN DE BOUCLE *)
                        i:=NbClas+1;
                      end
                    else
                      inc(i);
               end;
           end;
    end;
  (* REECRITURE DU CLASSEMENT SANS PRIMES SUR DISQUE *)
  if CREATION_FICHIER(hWindow)
     then
       begin
         i:=1; Ok:=true;
         while (i <= NbClas) and Ok do
           begin
             Ok:=ECRITURE_FICHIER(hWindow,Classement1^[i],40);
             inc(i);
           end;
         FERMETURE_FICHIER(hWindow);
       end;
  (* CHARGEMENT DU CLASSEMENT AVEC PRIMES *)
  LoadString(hInstance,st_NomFichier2,Parametres^.NomFichierCourant,13);
  if OUVERTURE_FICHIER(hWindow)
     then
       begin
         i:=1; Ok:=true;
         while (i <= NbClas) and Ok do
           begin
             Ok:=LECTURE_FICHIER(hWindow,Classement2^[i],40);
             inc(i);
           end;
         FERMETURE_FICHIER(hWindow);
       end;
  (* MISE A JOUR DU CLASSEMENT AVEC PRIMES AVEC LES RESULTATS DE LA PARTIE ACTUELLE *)
  for n:=1 to 10 do with Joueurs^[n] do
    begin
      if StrLen(NomJoueur) > 0
         then
           begin
             i:=1;
             while i <= NbClas do
               begin
                 s:=StrPas(Classement2^[i]);
                 Val(Copy(s,6,5),Valeur,Erreur);
                 if FeuillePoints[19,3] > Valeur
                    then   (* POINT D'INSERTION TROUVE : INSERTION DU RESULTAT DANS LE CLASSEMENT *)
                      begin
                        for j:=NbClas downto (i+1) do Classement2^[j]:=Classement2^[j-1];
                        for k:=1 to 10 do ChaineClas[k]:=' ';
                        Str(FeuillePoints[19,1],s); l:=Length(s); if l < 5 then for k:=1 to (5-l) do Insert(' ',s,1);
                        for k:=1 to 5 do ChaineClas[k]:=s[k];
                        Str(FeuillePoints[19,3],s); l:=Length(s); if l < 5 then for k:=1 to (5-l) do Insert(' ',s,1);
                        for k:=1 to 5 do ChaineClas[k+5]:=s[k];
                        ChaineClas[0]:=#10;
                        StrPCopy(Classement2^[i],ChaineClas);
                        StrCat(Classement2^[i],ChaineDate);
                        StrCat(Classement2^[i],NomJoueur);
                        (* FIN DE BOUCLE *)
                        i:=NbClas+1;
                      end
                    else
                      inc(i);
               end;
           end;
    end;
  (* REECRITURE DU CLASSEMENT SANS PRIMES SUR DISQUE *)
  if CREATION_FICHIER(hWindow)
     then
       begin
         i:=1; Ok:=true;
         while (i <= NbClas) and Ok do
           begin
             Ok:=ECRITURE_FICHIER(hWindow,Classement2^[i],40);
             inc(i);
           end;
         FERMETURE_FICHIER(hWindow);
       end;
  (* AFFICHAGE DU DIALOGUE AVEC LES DEUX CLASSEMENTS *)
  Application^.EXECDIALOG(pDlgClassements(New(pDlgClassements,INIT(@Self,'DIALOGUE_CLASSEMENTS'))));
  (* DECLENCHEMENT D'UNE NOUVELLE PARTIE *)
  PostMessage(hWindow,wm_Command,cm_NouvellePartie,0);
End;

Procedure tFenetrePrincipale.CMSCORES (var Msg : tMessage);
(* AFFICHAGE DES SCORES ACTUELS DE TOUS LES JOUEURS *)
Begin
  Application^.EXECDIALOG(pDlgResultats(New(pDlgResultats,INIT(@Self,'DIALOGUE_RESULTATS'))));
End;

Procedure tFenetrePrincipale.CMCLASSEMENT (var Msg : tMessage);
(* AFFICHAGE DES CLASSEMENTS *)
Const ChaineVierge = '                    '#0#0#0#0#0#0#0#0#0#0;
Var i : Word;       (* INDICE DANS LES CLASSEMENTS *)
    Ok : Boolean;   (* FIN DE BOUCLE SI ERREUR *)
Begin
  (* CLASSEMENTS VIERGES *)
  for i:=1 to NbClas do
    begin
      StrCopy(Classement1^[i],ChaineVierge);
      StrCopy(Classement2^[i],ChaineVierge);
    end;
  (* CHARGEMENT DU CLASSEMENT SANS PRIMES *)
  LoadString(hInstance,st_NomFichier1,Parametres^.NomFichierCourant,13);
  if OUVERTURE_FICHIER(hWindow)
     then
       begin
         i:=1; Ok:=true;
         while (i <= NbClas) and Ok do
           begin
             Ok:=LECTURE_FICHIER(hWindow,Classement1^[i],40);
             inc(i);
           end;
         FERMETURE_FICHIER(hWindow);
       end;
  (* CHARGEMENT DU CLASSEMENT AVEC PRIMES *)
  LoadString(hInstance,st_NomFichier2,Parametres^.NomFichierCourant,13);
  if OUVERTURE_FICHIER(hWindow)
     then
       begin
         i:=1; Ok:=true;
         while (i <= NbClas) and Ok do
           begin
             Ok:=LECTURE_FICHIER(hWindow,Classement2^[i],40);
             inc(i);
           end;
         FERMETURE_FICHIER(hWindow);
       end;
  (* AFFICHAGE DU DIALOGUE AVEC LES DEUX CLASSEMENTS *)
  Application^.EXECDIALOG(pDlgClassements(New(pDlgClassements,INIT(@Self,'DIALOGUE_CLASSEMENTS'))));
End;

Procedure tFenetrePrincipale.CMQUITTER (var Msg : tMessage);
(* QUITTER LE JEU *)
Begin
  CloseWindow;
End;

Procedure tFenetrePrincipale.CMPLEINEFENETRE (var Msg : tMessage);
(* AGRANDISSEMENT DES FENETRES DE JEU EN PLEIN ECRAN *)
Begin
  PostMessage(GetFocus,wm_SysCommand,sc_Maximize,0);
End;

Procedure tFenetrePrincipale.CMOPTIONSTRI (var Msg : tMessage);
(* OPTION DE TRI DES DES : COCHAGE CORRESPONDANT DU MENU *)
Begin
  if (GetMenuState(Attr.Menu,cm_OptionsTri,mf_ByCommand or mf_Checked) and mf_Checked) = mf_Checked
     then CheckMenuItem(Attr.Menu,cm_OptionsTri,mf_ByCommand or mf_UnChecked)
     else CheckMenuItem(Attr.Menu,cm_OptionsTri,mf_ByCommand or mf_Checked);
End;

Procedure tFenetrePrincipale.COULEUR_SELECTION (n : Word);
(* SELECTION DE LA COULEUR DES DES SELECTIONNES ET COCHAGE DU MENU CORRESPONDANT *)
Begin
  with Parametres^ do
    begin
      CheckMenuItem(Attr.Menu,cm_Couleur1+CouleurSelection-1,mf_ByCommand or mf_UnChecked);
      CouleurSelection:=n;
      CheckMenuItem(Attr.Menu,cm_Couleur1+n-1,mf_ByCommand or mf_Checked);
    end;
End;

Procedure tFenetrePrincipale.CMCONVERSION (var Msg : tMessage);
(* CONVERSION D'UN CLASSEMENT DE LA VERSION 2.xx VERS LA VERSION 3.00 *)
Const ChaineVierge = '                    '#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0;
Type AncienType = Record
                    NomJoueur, Date : String [15];
                    TotalSans, TotalAvec : Word;
                  end;
Var Continuer : Boolean;         (* INTERRUPTEUR DE BOUCLE *)
    i, k, l : Byte;              (* INDICES *)
    Valeur : Word;               (* CONVERSION DE CHAINE EN NOMBRE *)
    Erreur : Integer;            (* RESULTAT DE LA CONVERSION *)
    Chaine : Str40;              (* NOUVELLE CHAINE CONSTRUITE *)
    s1, s2 : String [40];        (* CONSTRUCTION DE LA CHAINE DE CLASSEMENT *)
    c : Array [0..15] of Char;   (* CHAINE DE CONVERSION ASCII -> ASCII *)
    Ancien : AncienType;         (* TRANSTYPAGE DE LA CHAINE LUE *)
Begin
  Application^.EXECDIALOG(pDlgConversion(New(pDlgConversion,INIT(@Self,'DIALOGUE_CONVERSION'))));
  with Parametres^ do
    begin
      (* CLASSEMENTS VIERGES *)
      for i:=1 to NbClas do
        begin
          StrCopy(Classement1^[i],ChaineVierge);
          StrCopy(Classement2^[i],ChaineVierge);
        end;
      (* CHARGEMENT DU CLASSEMENT SANS PRIMES *)
      StrCopy(NomFichierCourant,Source1);
      if OUVERTURE_FICHIER(hWindow)
         then
           begin
             i:=1; Continuer:=true;
             while (i <= 20) and Continuer do
               begin
                 Continuer:=LECTURE_FICHIER(hWindow,Classement1^[i],36);
                 inc(i);
               end;
             FERMETURE_FICHIER(hWindow);
           end;
      if Continuer
         then   (* CONVERSION *)
           for i:=1 to 20 do
             begin
               Move(Classement1^[i],Ancien,36);
               with Ancien do
                 begin
                   for k:=1 to 10 do s1[k]:=' ';
                   Str(TotalSans,s2); l:=Length(s2); if l < 5 then for k:=1 to (5-l) do Insert(' ',s2,1);
                   for k:=1 to 5 do s1[k]:=s2[k];
                   Str(TotalAvec,s2); l:=Length(s2); if l < 5 then for k:=1 to (5-l) do Insert(' ',s2,1);
                   for k:=1 to 5 do s1[k+5]:=s2[k];
                   s1[0]:=#10;
                   s1:=s1 + Date; StrPCopy(Classement1^[i],s1);
                   StrPCopy(c,NomJoueur); OEMToAnsi(c,c); StrCat(Classement1^[i],c);
                 end;
             end;
      if Continuer
         then   (* REECRITURE DU CLASSEMENT SANS PRIMES *)
           begin
             if CREATION_FICHIER(hWindow)
                then
                  begin
                    i:=1;
                    while (i <= NbClas) and Continuer do
                      begin
                        Continuer:=ECRITURE_FICHIER(hWindow,Classement1^[i],40);
                        inc(i);
                      end;
                    FERMETURE_FICHIER(hWindow);
                  end;
           end;


    end;
  (* AFFICHAGE DU DIALOGUE AVEC LES DEUX CLASSEMENTS *)
  Application^.EXECDIALOG(pDlgClassements(New(pDlgClassements,INIT(@Self,'DIALOGUE_CLASSEMENTS'))));
End;

Procedure tFenetrePrincipale.CMFUSION (var Msg : tMessage);
(* FUSION DE DEUX CLASSEMENTS EN UN SEUL *)
Const ChaineVierge = '                    '#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0;
Var Continuer : Boolean;       (* INTERRUPTEUR DE BOUCLE *)
    i, j, n : Byte;            (* INDICES *)
    Valeur1, Valeur2 : Word;   (* CONVERSION DE CHAINE EN NOMBRE *)
    Erreur : Integer;          (* RESULTAT DE LA CONVERSION *)
    ChaineSource : Str40;      (* ELEMENT DU CLASSEMENT SOURCE *)
    s : String [40];           (* CONSTRUCTION DE LA CHAINE DE CLASSEMENT *)
Begin
  Application^.EXECDIALOG(pDlgFusion(New(pDlgFusion,INIT(@Self,'DIALOGUE_FUSION'))));
  with Parametres^ do
    begin
      (* CLASSEMENTS VIERGES *)
      for i:=1 to NbClas do
        begin
          StrCopy(Classement1^[i],ChaineVierge);
          StrCopy(Classement2^[i],ChaineVierge);
        end;
      (* CHARGEMENT DU CLASSEMENT SANS PRIMES DESTINATION *)
      StrCopy(NomFichierCourant,Dest1);
      if OUVERTURE_FICHIER(hWindow)
         then
           begin
             i:=1; Continuer:=true;
             while (i <= NbClas) and Continuer do
               begin
                 Continuer:=LECTURE_FICHIER(hWindow,Classement1^[i],40);
                 inc(i);
               end;
             FERMETURE_FICHIER(hWindow);
           end;
      if Continuer
         then   (* LECTURE DU CLASSEMENT SANS PRIMES SOURCE *)
           begin
             StrCopy(NomFichierCourant,Source1);
             if OUVERTURE_FICHIER(hWindow)
                then
                  begin
                    n:=1;
                    while (n <= NbClas) and Continuer do
                      begin
                        Continuer:=LECTURE_FICHIER(hWindow,ChaineSource,40);
                        if Continuer
                           then
                             begin
                               s:=StrPas(ChaineSource); Val(Copy(s,1,5),Valeur1,Erreur);
                               i:=1;
                               while i <= NbClas do
                                 if EviterRedondance and (StrComp(ChaineSource,Classement1^[i]) = 0)
                                    then   (* ELEMENT REDONDANT : FIN DE BOUCLE *)
                                      i:=NbClas+1
                                    else   (* ELEMENT NON REDONDANT *)
                                      begin
                                        s:=StrPas(Classement1^[i]); Val(Copy(s,1,5),Valeur2,Erreur);
                                        if Valeur1 > Valeur2
                                          then   (* POINT D'INSERTION TROUVE : INSERTION DU RESULTAT DANS LE CLASSEMENT *)
                                            begin
                                              for j:=NbClas downto (i+1) do Classement1^[j]:=Classement1^[j-1];
                                              StrCopy(Classement1^[i],ChaineSource);
                                              (* FIN DE BOUCLE *)
                                              i:=NbClas+1;
                                            end
                                          else
                                            inc(i);
                                      end;
                             end;
                        inc(n);
                      end;
                    FERMETURE_FICHIER(hWindow);
                  end;
           end;
      if Continuer
         then   (* REECRITURE DU CLASSEMENT SANS PRIMES DESTINATION *)
           begin
             StrCopy(NomFichierCourant,Dest1);
             if CREATION_FICHIER(hWindow)
                then
                  begin
                    i:=1;
                    while (i <= NbClas) and Continuer do
                      begin
                        Continuer:=ECRITURE_FICHIER(hWindow,Classement1^[i],40);
                        inc(i);
                      end;
                    FERMETURE_FICHIER(hWindow);
                  end;
           end;
      (* CHARGEMENT DU CLASSEMENT AVEC PRIMES DESTINATION *)
      StrCopy(NomFichierCourant,Dest2);
      if OUVERTURE_FICHIER(hWindow)
         then
           begin
             i:=1; Continuer:=true;
             while (i <= NbClas) and Continuer do
               begin
                 Continuer:=LECTURE_FICHIER(hWindow,Classement2^[i],40);
                 inc(i);
               end;
             FERMETURE_FICHIER(hWindow);
           end;
      if Continuer
         then   (* LECTURE DU CLASSEMENT AVEC PRIMES SOURCE *)
           begin
             StrCopy(NomFichierCourant,Source2);
             if OUVERTURE_FICHIER(hWindow)
                then
                  begin
                    n:=1;
                    while (n <= NbClas) and Continuer do
                      begin
                        Continuer:=LECTURE_FICHIER(hWindow,ChaineSource,40);
                        if Continuer
                           then
                             begin
                               s:=StrPas(ChaineSource); Val(Copy(s,1,5),Valeur1,Erreur);
                               i:=1;
                               while i <= NbClas do
                                 if EviterRedondance and (StrComp(ChaineSource,Classement2^[i]) = 0)
                                    then   (* ELEMENT REDONDANT : FIN DE BOUCLE *)
                                      i:=NbClas+1
                                    else   (* ELEMENT NON REDONDANT *)
                                      begin
                                        s:=StrPas(Classement2^[i]); Val(Copy(s,1,5),Valeur2,Erreur);
                                        if Valeur1 > Valeur2
                                          then   (* POINT D'INSERTION TROUVE : INSERTION DU RESULTAT DANS LE CLASSEMENT *)
                                            begin
                                              for j:=NbClas downto (i+1) do Classement2^[j]:=Classement2^[j-1];
                                              StrCopy(Classement2^[i],ChaineSource);
                                              (* FIN DE BOUCLE *)
                                              i:=NbClas+1;
                                            end
                                          else
                                            inc(i);
                                      end;
                             end;
                        inc(n);
                      end;
                    FERMETURE_FICHIER(hWindow);
                  end;
           end;
      if Continuer
         then   (* REECRITURE DU CLASSEMENT SANS PRIMES DESTINATION *)
           begin
             StrCopy(NomFichierCourant,Dest2);
             if CREATION_FICHIER(hWindow)
                then
                  begin
                    i:=1; Continuer:=true;
                    while (i <= NbClas) and Continuer do
                      begin
                        Continuer:=ECRITURE_FICHIER(hWindow,Classement2^[i],40);
                        inc(i);
                      end;
                    FERMETURE_FICHIER(hWindow);
                  end;
           end;
    end;
  (* AFFICHAGE DU DIALOGUE AVEC LES DEUX CLASSEMENTS *)
  Application^.EXECDIALOG(pDlgClassements(New(pDlgClassements,INIT(@Self,'DIALOGUE_CLASSEMENTS'))));
End;

Procedure tFenetrePrincipale.CMAIDE (var Msg : tMessage);
(* ACCES A L'AIDE *)
Var c : Array [0..12] of Char;   (* NOM DU FICHIER HLP *)
Begin
  LoadString(hInstance,st_NomFichierAide,c,SizeOf(c));
  WinHelp(hWindow,c,help_Index,0);
End;

Procedure tFenetrePrincipale.CMAPROPOS (var Msg : tMessage);
(* AFFICHAGE DU DIALOGUE "A PROPOS DE" *)
Begin
  Application^.ExecDialog(New(pDlgAPropos,INIT(@Self,'DIALOGUE_APROPOS')));
End;

Function tFenetrePrincipale.CANCLOSE : Boolean;
(* FIN DE PROGRAMME APRES CONFIRMATION *)
Var Message : Array [0..75] of Char;   (* TEXTE DE LA BOITE MESSAGE *)
    Titre : Array [0..25] of Char;     (* TITRE DE LA BOITE MESSAGE *)
Begin
  LoadString(hInstance,st_TexteQuitter,Message,SizeOf(Message));
  LoadString(hInstance,st_TitreQuitter,Titre,SizeOf(Titre));
  CANCLOSE:=(MessageBox(hWindow,Message,Titre,mb_YesNo or mb_IconQuestion) = id_Yes);
End;

Destructor tFenetrePrincipale.DONE;
(* DESALLOCATION DES OBJETS ET DES VARIABLES DYNAMIQUES ET SORTIE DU PROGRAMME *)
Var i : Byte;   (* INDICE *)
Begin
  for i:=1 to 10 do with Joueurs^[i] do if FenetreMDI <> nil then FenetreMDI^.CloseWindow;
  if Joueurs <> nil then Dispose(Joueurs);
  if TableauDes <> nil then Dispose(TableauDes);
  if Classement1 <> nil then Dispose(Classement1);
  if Classement2 <> nil then Dispose(Classement2);
  if Parametres <> nil
     then
       begin
         with Parametres^ do
           begin
             if hImageLogo <> 0 then DeleteObject(hImageLogo);
             if hImageFeuille <> 0 then DeleteObject(hImageFeuille);
           end;
         Dispose(Parametres);
       end;
  tMDIWindow.DONE;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                           METHODES DE L'OBJET tFenetreJeu                                            *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Constructor tFenetreJeu.INIT (FenetreParent : pWindowsObject; Titre : pChar; Index : Byte);
(* DEFINITION DU STYLE DE LA FENETRE, CREATION DES CONTROLES ENFANTS *)
Var TexteBouton : Array [0..14] of Char;   (* TEXTE DU BOUTON *)
    n : Integer;                           (* INDEX DU TEXTE DANS LA TABLE DE CHAINES *)
Begin
  tWindow.INIT(FenetreParent,Titre);
  IndexJoueur:=Index;
  (* STYLE DE LA FENETRE *)
  with Attr do
    begin
      Style:=ws_Child;
      with Parametres^ do
        begin
          w:=wFenetreJeu;
          h:=hFenetreJeu;
        end;
    end;
  (* CONTROLES ENFANTS *)
  with Parametres^ do
    begin
      LoadString(hInstance,st_TexteDeRelancer,TexteBouton,9);
      with TableauDes^[1] do
        TabBoutonsDes[1]:=New(pButton,INIT(@Self,id_BoutonDe1,TexteBouton,x1B,y1B,wBoutonsDes,hBoutonsDes,false));
      with TableauDes^[2] do
        TabBoutonsDes[2]:=New(pButton,INIT(@Self,id_BoutonDe2,TexteBouton,x1B,y1B,wBoutonsDes,hBoutonsDes,false));
      with TableauDes^[3] do
        TabBoutonsDes[3]:=New(pButton,INIT(@Self,id_BoutonDe3,TexteBouton,x1B,y1B,wBoutonsDes,hBoutonsDes,false));
      with TableauDes^[4] do
        TabBoutonsDes[4]:=New(pButton,INIT(@Self,id_BoutonDe4,TexteBouton,x1B,y1B,wBoutonsDes,hBoutonsDes,false));
      with TableauDes^[5] do
        TabBoutonsDes[5]:=New(pButton,INIT(@Self,id_BoutonDe5,TexteBouton,x1B,y1B,wBoutonsDes,hBoutonsDes,false));
      if HauteResolution then n:=st_TexteLancerDesHR else n:=st_TexteLancerDes;
      LoadString(hInstance,n,TexteBouton,15);
      BoutonCmd1:=New(pButton,INIT(@Self,id_BoutonCmd1,TexteBouton,xBoutonCmd,yBoutonCmd,wBoutonCmd,hBoutonCmd,false));
      LoadString(hInstance,st_TexteCorriger,TexteBouton,9);
      BoutonCmd2:=New(pButton,INIT(@Self,id_BoutonCmd2,TexteBouton,xBoutonCmd,yBoutonCmd+hBoutonCmd+dBoutonCmd,
                                   wBoutonCmd,hBoutonCmd,false));
    end;
End;

Procedure tFenetreJeu.GETWINDOWCLASS (var aWndClass : tWndClass);
(* DEFINITION DE L'ICONE DE FENETRE *)
Begin
  tWindow.GETWINDOWCLASS(aWndClass);
  aWndClass.hIcon:=LoadIcon(hInstance,'ICONE_FENETRE_PRINCIPALE');
End;

Procedure tFenetreJeu.SETUPWINDOW;
(* INITIALISATION DES DES ET DE LA FEUILLE DE POINTS *)
Var i, j : Byte;   (* INDICES DANS LES TABLEAUX *)
Begin
  tWindow.SETUPWINDOW;
  (* PREPARATION DU LANCER DES DES *)
  PREPARATION_PREMIER_LANCER_DES;
  with Joueurs^[IndexJoueur] do
    begin
      (* INITIALISATION DE LA FEUILLE DE POINTS (FFFFh SIGNIFIE "NON REMPLIE" *)
      for i:=1 to 6 do for j:=1 to 3 do FeuillePoints[i,j]:=$FFFF;
      for i:=7 to 9 do for j:=1 to 3 do FeuillePoints[i,j]:=0;
      for i:=10 to 16 do for j:=1 to 3 do FeuillePoints[i,j]:=$FFFF;
      for i:=17 to 19 do for j:=1 to 3 do FeuillePoints[i,j]:=0;
      (* INITIALISATION DU NOMBRE DE COUPS JOUES *)
      CoupsJoues:=0;
    end;
End;

Procedure tFenetreJeu.PAINT (PaintDC : hDC; var PaintInfo : tPaintStruct);
(* DESSIN DU CONTENU DE LA FENETRE *)
Var MemDC : hDC;                            (* CONTEXTE D'AFFICHAGE VIRTUEL *)
    hAncienneBitmap : hBitmap;              (* ANCIENNE BITMAP LIEE AU CONTEXTE D'AFFICHAGE VIRTUEL *)
    hAncienPinceau, hPinceau : hBrush;      (* ANCIEN ET NOUVEAU PINCEAU *)
    hAncienCrayon, hCrayon : hPen;          (* ANCIEN ET NOUVEAU CRAYON *)
    AncienneCouleur, Couleur : tColorRef;   (* COULEUR D'AFFICHAGE DU NOMBRE DE LANCERS RESTANTS *)
    x1, y1, x2, y2 : Integer;               (* COORDONNEES RECTANGLE DU CONTOUR DES BOUTONS DE CHOIX DES DES *)
    c : Array [0..21] of Char;              (* TEXTE DU NOMBRE DE LANCERS RESTANTS *)
    n, l : Integer;                         (* INDEX ET LONGUEUR DU TEXTE DANS LA TABLE DE CHAINES *)
Begin
  with Parametres^ do
    begin
      MemDC:=CreateCompatibleDC(PaintDC);
      (* FEUILLE DE POINTS ET LOGO *)
      hAncienneBitmap:=SelectObject(MemDC,hImageFeuille);
      BitBlt(PaintDC,xFeuille,yFeuille,wFeuille,hFeuille,MemDC,0,0,SrcCopy);
      if HauteResolution
         then   (* ECRAN HAUTE RESOLUTION : DESSIN DU LOGO AU-DESSUS DE LA FEUILLE DE POINTS *)
           begin
             SelectObject(MemDC,hImageLogo);
             BitBlt(PaintDC,xLogo,yLogo,wLogo,hLogo,MemDC,0,0,SrcCopy);
           end;
      SelectObject(MemDC,hAncienneBitmap);
      DeleteDC(MemDC);
      (* DES *)
      for n:=1 to 5 do DESSIN_DE(n);
      (* POINTS *)
      AFFICHAGE_POINTS;
      (* CONTOUR AUTOUR DE L'OBJET COURANT *)
      case ActionCourante of
        ac_ChoixDes : CONTOUR_BOUTON_DE(DeCourant);
        ac_Inscription : CONTOUR_CASE_FEUILLE(Ligne,Colonne,true);
        ac_Commande : CONTOUR_BOUTON_COMMANDE(BoutonCommande);
      end;
      (* DESALLOCATION DES OUTILS DE DESSIN DU CONTOUR *)
      SelectObject(PaintDC,hAncienCrayon);
      DeleteObject(hCrayon);
      (* INDICATION DU NOMBRE DE LANCERS RESTANTS *)
      if HauteResolution then begin n:=st_NombreLancersHR; l:=22; end else begin n:=st_NombreLancers; l:=11; end;
      LoadString(hInstance,n,c,l);
      AncienneCouleur:=SetTextColor(PaintDC,RGB(0,0,0));
      TextOut(PaintDC,xDe,(yDe div 2)-7,c,l-1);
      AFFICHAGE_NOMBRE_LANCERS;
      SetTextColor(PaintDC,AncienneCouleur);
    end;
End;

Procedure tFenetreJeu.AFFICHAGE_POINTS;
(* AFFICHAGE DES POINTS DANS LA FEUILLE DE POINTS *)
Var DC : hDC;                               (* CONTEXTE D'AFFICHAGE *)
    l, c : Byte;                            (* INDICES DANS LA FEUILLE DE POINTS *)
    h, d : Integer;                         (* ORDONNEE ET DECALAGE DE DESSIN DES TOTAUX (SI HAUTE RESOLUTION OU NON) *)
    AncienAlignement : Word;                (* ALIGNEMENT INITIAL DU TEXTE *)
    Couleurs : Array [1..5] of tColorRef;   (* COULEURS D'AFFICHAGE DES TROIS COLONNES ET DES TOTAUX *)
    AncienneCouleur : tColorRef;            (* COULEUR INITIALE *)
    s : String [5];                         (* CHAINE DE CONVERSION DES NOMBRES *)
    a : Array [0..5] of Char;               (* TEXTE A AFFICHER *)
Begin
  DC:=GetDC(hWindow);
  Couleurs[1]:=RGB(0,0,255); Couleurs[2]:=RGB(255,0,0); Couleurs[3]:=GetNearestColor(DC,RGB(255,0,255));
  Couleurs[4]:=RGB(0,0,0); Couleurs[5]:=RGB(255,0,0);
  AncienAlignement:=SetTextAlign(DC,ta_Center or ta_BaseLine);
  AncienneCouleur:=GetTextColor(DC);
  with Joueurs^[IndexJoueur] do with Parametres^ do
    begin
      (* SECTION SUPERIEURE *)
      l:=1; c:=1;
      repeat
        if FeuillePoints[l,c] <> $FFFF
           then
             begin
               SetTextColor(DC,Couleurs[c]);
               Str(Feuillepoints[l,c],s); StrPCopy(a,s);
               TextOut(DC,RectSectionSup.Left+((c-1)*53)+27,RectSectionSup.Top+((l-1)*20)+16,a,StrLen(a));
             end;
        if c = 3
           then
             begin
               c:=1; inc(l);
             end
           else
             inc(c);
      until l > 6;
      (* SECTION INFERIEURE *)
      l:=10; c:=1;
      repeat
        if FeuillePoints[l,c] <> $FFFF
           then
             begin
               SetTextColor(DC,Couleurs[c]);
               Str(Feuillepoints[l,c],s); StrPCopy(a,s);
               TextOut(DC,RectSectionInf.Left+((c-1)*53)+27,RectSectionInf.Top+((l-10)*20)+16,a,StrLen(a));
             end;
        if c = 3
           then
             begin
               c:=1; inc(l);
             end
           else
             inc(c);
      until l > 16;
      (* TOTAUX DE LA SECTION SUPERIEURE *)
      SetTextColor(DC,Couleurs[4]);
      for c:=1 to 3 do
        begin
          if HauteResolution
             then
               begin
                 if FeuillePoints[7,c] <> 0
                    then
                      begin
                        Str(Feuillepoints[7,c],s); StrPCopy(a,s);
                        TextOut(DC,RectSectionSup.Left+(c-1)*53+27,RectSectionSup.Top+(6*20)+16,a,StrLen(a));
                      end;
                 if Feuillepoints[8,c] <> 0
                    then
                      begin
                        Str(Feuillepoints[8,c],s); StrPCopy(a,s);
                        TextOut(DC,RectSectionSup.Left+(c-1)*53+27,RectSectionSup.Top+(7*20)+17,a,StrLen(a));
                      end;
                 h:=8; d:=18;
               end
             else
               begin
                 h:=6; d:=16;
               end;
          if Feuillepoints[9,c] <> 0
             then
               begin
                 Str(Feuillepoints[9,c],s); StrPCopy(a,s);
                 TextOut(DC,RectSectionSup.Left+(c-1)*53+27,RectSectionSup.Top+(h*20)+d,a,StrLen(a));
               end;
        end;
      (* TOTAUX DE LA SECTION INFERIEURE *)
      for c:=1 to 3 do
        begin
          if FeuillePoints[17,c] <> 0
             then
               begin
                 Str(Feuillepoints[17,c],s); StrPCopy(a,s);
                 TextOut(DC,RectSectionInf.Left+(c-1)*53+27,RectSectionInf.Top+(7*20)+16,a,StrLen(a));
               end;
          if Feuillepoints[18,c] <> 0
             then
               begin
                 Str(Feuillepoints[18,c],s); StrPCopy(a,s);
                 TextOut(DC,RectSectionInf.Left+(c-1)*53+27,RectSectionInf.Top+(8*20)+17,a,StrLen(a));
               end;
        end;
      (* TOTAL GENERAL *)
      SetTextColor(DC,Couleurs[5]);
      if Feuillepoints[19,3] <> 0
         then
           begin
             Str(Feuillepoints[19,1],s); StrPCopy(a,s);
             TextOut(DC,RectSectionInf.Left+53+27,RectSectionInf.Top+(9*20)+18,a,StrLen(a));
           end;
    end;
  SetTextAlign(DC,AncienAlignement);
  SetTextColor(DC,AncienneCouleur);
  ReleaseDC(hWindow,DC);
End;

Procedure tFenetreJeu.DESSIN_DE (n : Byte);
(* DESSINE UN DE - SA COULEUR INDIQUE S'IL EST SELECTIONNE OU PAS *)
Var  DC : hDC;                            (* CONTEXTE D'AFFICHAGE *)
     hAncienPinceau, hPinceau : hBrush;   (* PINCEAUX (D'ORIGINE ET CREE PAR LA PROCEDURE) *)
     hAncienCrayon, hCrayon : hPen;       (* CRAYONS (D'ORIGINE ET CREE PAR LA PROCEDURE) *)
     xPt, yPt : Integer;                  (* COORDONNEES DU CENTRE D'UN POINT *)
     Couleur : tColorRef;                 (* COULEUR DE FOND DU DE *)
Begin
  DC:=GetDC(hWindow);
  with Parametres^ do with TableauDes^[n] do
    begin
      (* CONTOUR DU DE *)
      if Selection then Couleur:=TabCouleurs[CouleurSelection] else Couleur:=GetNearestColor(DC,RGB(240,240,210));
      hPinceau:=CreateSolidBrush(Couleur);
      hAncienPinceau:=SelectObject(DC,hPinceau);
      hCrayon:=CreatePen(ps_Solid,2,RGB(0,0,0));
      hAncienCrayon:=SelectObject(DC,hCrayon);
      RoundRect(DC,x1D,y1D,x2D,y2D,16,16);
      SelectObject(DC,hAncienPinceau);
      DeleteObject(hPinceau);
      (* POINTS *)
      hPinceau:=CreateSolidBrush(RGB(0,0,0));
      hAncienPinceau:=SelectObject(DC,hPinceau);
      case Montant of
        1 : begin
              xPt:=x1D+(wDe div 2); yPt:=y1D+(hDe div 2);
              Ellipse(DC,xPt-lPt,yPt-Parametres^.lPt,xPt+lPt,yPt+lPt);
            end;
        2 : begin
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 4);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 4)*3;
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
            end;
        3 : begin
              xPt:=x1D+(wDe div 2); yPt:=y1D+(hDe div 2);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 4);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 4)*3;
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
            end;
        4 : begin
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 4);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 4);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 4)*3;
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 4)*3;
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
            end;
        5 : begin
              xPt:=x1D+(wDe div 2); yPt:=y1D+(hDe div 2);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 4);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 4);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 4)*3;
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 4)*3;
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
            end;
        6 : begin
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 4);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 4);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 2);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 2);
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4); yPt:=y1D+(hDe div 4)*3;
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
              xPt:=x1D+(wDe div 4)*3; yPt:=y1D+(hDe div 4)*3;
              Ellipse(DC,xPt-lPt,yPt-lPt,xPt+lPt,yPt+lPt);
            end;
      end;
    end;
  (* DESALLOCATION DES OUTILS *)
  SelectObject(DC,hAncienPinceau);
  DeleteObject(hPinceau);
  SelectObject(DC,hAncienCrayon);
  DeleteObject(hCrayon);
  ReleaseDC(hWindow,DC);
End;

Procedure tFenetreJeu.CONTOUR_BOUTON_DE (n : Byte);
(* DESSINE OU EFFACE LE CONTOUR AUTOUR D'UN BOUTON DE CHOIX DE DE *)
Var DC : hDC;                            (* CONTEXTE D'AFFICHAGE *)
    hAncienPinceau, hPinceau : hBrush;   (* PINCEAUX (D'ORIGINE ET CREE PAR LA PROCEDURE) *)
    hAncienCrayon, hCrayon : hPen;       (* CRAYONS (D'ORIGINE ET CREE PAR LA PROCEDURE) *)
    AncienneROP : Integer;               (* ANCIENNE OPERATION D'AFFICHAGE *)
Begin
  DC:=GetDC(hWindow);
  AncienneROP:=SetROP2(DC,r2_Not);
  hPinceau:=CreateSolidBrush(GetSysColor(color_Window));
  hAncienPinceau:=SelectObject(DC,hPinceau);
  hCrayon:=CreatePen(ps_Solid,1,GetSysColor(color_Window));
  hAncienCrayon:=SelectObject(DC,hCrayon);
  with TableauDes^[n] do
    begin
      Rectangle(DC,x1B-3,y1B-3,x2B+3,y1B);
      Rectangle(DC,x1B-3,y2B,x2B+3,y2B+3);
      Rectangle(DC,x1B-3,y1B,x1B,y2B);
      Rectangle(DC,x2B,y1B,x2B+3,y2B);
    end;
  (* DESALLOCATION DES OUTILS *)
  SelectObject(DC,hAncienPinceau);
  DeleteObject(hPinceau);
  SelectObject(DC,hAncienCrayon);
  DeleteObject(hCrayon);
  SetROP2(DC,AncienneROP);
  ReleaseDC(hWindow,DC);
End;

Procedure tFenetreJeu.CONTOUR_CASE_FEUILLE (l, c : Byte; Surbriller : Boolean);
(* DESSINE OU EFFACE LE CONTOUR DE LA CASE A LA LIGNE l ET A LA COLONNE c DE LA FEUILLE DE POINTS *)
Var DC : hDC;                            (* CONTEXTE D'AFFICHAGE *)
    hAncienPinceau, hPinceau : hBrush;   (* PINCEAUX (D'ORIGINE ET CREE PAR LA PROCEDURE) *)
    hAncienCrayon, hCrayon : hPen;       (* CRAYONS (D'ORIGINE ET CREE PAR LA PROCEDURE) *)
    Couleur : tColorRef;                 (* COULEUR DE DESSIN DU CONTOUR *)
    x1, y1, x2, y2 : Integer;            (* COORDONNEES INTERIEURES DE LA CASE *)
Begin
  DC:=GetDC(hWindow);
  if Surbriller then Couleur:=RGB(255,0,0) else Couleur:=RGB(255,255,255);
  hPinceau:=CreateSolidBrush(Couleur);
  hAncienPinceau:=SelectObject(DC,hPinceau);
  hCrayon:=CreatePen(ps_Solid,1,Couleur);
  hAncienCrayon:=SelectObject(DC,hCrayon);
  with Parametres^ do
    if l <= 6
       then with RectSectionSup do  (* SECTION SUPERIEURE *)
         begin
           x1:=Left+((c-1)*53)+1; y1:=Top+((l-1)*20)+1;
         end
       else with RectSectionInf do  (* SECTION INFERIEURE *)
         begin
           x1:=Left+((c-1)*53)+1; y1:=Top+((l-PremiereLigneInf)*20)+1;
         end;
  x2:=x1+52; y2:=y1+19;
  Rectangle(DC,x1,y1,x2,y1+2);
  Rectangle(DC,x1,y2-2,x2,y2);
  Rectangle(DC,x1,y1+2,x1+2,y2-2);
  Rectangle(DC,x2-2,y1+2,x2,y2-2);
  (* DESALLOCATION DES OUTILS *)
  SelectObject(DC,hAncienPinceau);
  DeleteObject(hPinceau);
  SelectObject(DC,hAncienCrayon);
  DeleteObject(hCrayon);
  ReleaseDC(hWindow,DC);
End;

Procedure tFenetreJeu.CONTOUR_BOUTON_COMMANDE (n : Byte);
(* DESSINE OU EFFACE LE CONTOUR AUTOUR D'UN BOUTON DE COMMANDE *)
Var DC : hDC;                            (* CONTEXTE D'AFFICHAGE *)
    hAncienPinceau, hPinceau : hBrush;   (* PINCEAUX (D'ORIGINE ET CREE PAR LA PROCEDURE) *)
    hAncienCrayon, hCrayon : hPen;       (* CRAYONS (D'ORIGINE ET CREE PAR LA PROCEDURE) *)
    AncienneROP : Integer;               (* ANCIENNE OPERATION D'AFFICHAGE *)
Begin
  DC:=GetDC(hWindow);
  AncienneROP:=SetROP2(DC,r2_Not);
  hPinceau:=CreateSolidBrush(GetSysColor(color_Window));
  hAncienPinceau:=SelectObject(DC,hPinceau);
  hCrayon:=CreatePen(ps_Solid,1,GetSysColor(color_Window));
  hAncienCrayon:=SelectObject(DC,hCrayon);
  with Parametres^ do
    begin
      Rectangle(DC,x1C-3,y1C+(n-1)*(hBoutonCmd+dBoutonCmd)-3,x2C+3,y1C+(n-1)*(hBoutonCmd+dBoutonCmd));
      Rectangle(DC,x1C-3,y2C+(n-1)*(hBoutonCmd+dBoutonCmd),x2C+3,y2C+(n-1)*(hBoutonCmd+dBoutonCmd)+3);
      Rectangle(DC,x1C-3,y1C+(n-1)*(hBoutonCmd+dBoutonCmd),x1C,y2C+(n-1)*(hBoutonCmd+dBoutonCmd));
      Rectangle(DC,x2C,y1C+(n-1)*(hBoutonCmd+dBoutonCmd),x2C+3,y2C+(n-1)*(hBoutonCmd+dBoutonCmd));
    end;
  (* DESALLOCATION DES OUTILS *)
  SelectObject(DC,hAncienPinceau);
  DeleteObject(hPinceau);
  SelectObject(DC,hAncienCrayon);
  DeleteObject(hCrayon);
  SetROP2(DC,AncienneROP);
  ReleaseDC(hWindow,DC);
End;

Procedure tFenetreJeu.AFFICHAGE_NOMBRE_LANCERS;
(* AFFICHAGE DU NOMBRE DE LANCERS RESTANTS *)
Var DC : hDC;                      (* CONTEXTE D'AFFICHAGE *)
    n, l : Integer;                (* INDEX DANS LA TABLE DE CHAINES ET LONGUEUR DE LA CHAINE *)
    c : Array [0..21] of Char;     (* TEXTE DU NOMBRE DE LANCERS RESTANTS *)
    s : String [1];                (* CHAINE DE CONVERSION *)
    x, y : Integer;                (* COORDONNEES DU TEXTE A AFFICHER *)
    AncienneCouleur : tColorRef;   (* COULEUR DE TEXTE D'ORIGINE *)
Begin
  DC:=GetDC(hWindow);
  with Parametres^ do
    begin
      if HauteResolution then begin n:=st_NombreLancersHR; l:=22; end else begin n:=st_NombreLancers; l:=11; end;
      LoadString(hInstance,n,c,l);
      AncienneCouleur:=SetTextColor(DC,RGB(255,0,0));
      l:=GetTextExtent(DC,c,StrLen(c));
      x:=xDe+l; y:=(yDe div 2)-7;
      TextOut(DC,x,y,'  ',2);   (* CHAINE BLANCHE *)
      Str(NbLancers,s); StrPCopy(c,s);
      TextOut(DC,x,y,c,1);
      SetTextColor(DC,AncienneCouleur);
    end;
  ReleaseDC(hWindow,DC);
End;

Procedure tFenetreJeu.ACTIVATION_BOUTON_DE (n : Byte);
(* REACTION A L'ACTIVATION D'UN BOUTON DE CHOIX DES DES *)
Var c : Array [0..9] of Char;   (* TEXTE DU BOUTON *)
    i, l : Integer;             (* INDEX ET LONGUEUR DE LA CHAINE DANS LA TABLE *)
Begin
  with Parametres^ do
    if ActionCourante = ac_ChoixDes
       then with TableauDes^[n] do
         begin
           (* EFFACEMENT DU CONTOUR AUTOUR DU BOUTON COURANT *)
           CONTOUR_BOUTON_DE(DeCourant);
           (* CONTOUR AUTOUR DU BOUTON SELECTIONNE *)
           CONTOUR_BOUTON_DE(n);
           Selection:=not Selection;
           DeCourant:=n;
           (* MODIFICATION DU TEXTE DU BOUTON *)
           if Selection then begin i:=st_TexteDeGarder; l:=7; end else begin i:=st_TexteDeRelancer; l:=9; end;
           LoadString(hInstance,i,c,l);
           TabBoutonsDes[n]^.SetCaption(c);
           (* DESSIN DU DE DANS LA BONNE COULEUR *)
           DESSIN_DE(n);
         end;
End;

Procedure tFenetreJeu.TRI_DES;
(* TRI DES CINQ DES PAR ORDRE CROISSANT *)
Var l, m, n, Sauve : Byte;   (* INDICES ET VARIABLE DE STOCKAGE TEMPORAIRE *)
Begin
  l:=1;
  while l <= 4 do
    begin
      m:=l+1;
      while m <= 5 do
        begin
          if TableauDes^[m].Montant < TableauDes^[l].Montant
             then
               begin
                 Sauve:=TableauDes^[m].Montant;
                 for n:=m downto (l+1) do TableauDes^[n].Montant:=TableauDes^[n-1].Montant;
                 TableauDes^[l].Montant:=Sauve;
               end;
          Inc(m);
        end;
      Inc(l);
    end;
End;

Procedure tFenetreJeu.PREPARATION_PREMIER_LANCER_DES;
(* PREPARATION DU PREMIER LANCER DE DES DU COUP COURANT *)
Var i : Byte;                    (* INDICE DANS LE TABLEAU DES DES OU DES BOUTONS DE CHOIX DES DES *)
    n : Word;                    (* RESULTAT DU TEST DU COCHAGE DE L'OPTION DE TRI DANS LE MENU / INDICE DE CHAINE *)
    c : Array [0..14] of Char;   (* TEXTE DES BOUTONS *)
Begin
  (* TEXTE DU PREMIER BOUTON DE COMMANDE *)
  if Parametres^.HauteResolution then n:=st_TexteLancerDesHR else n:=st_TexteLancerDes;
  LoadString(hInstance,n,c,15);
  BoutonCmd1^.SetCaption(c);
  EnableWindow(BoutonCmd1^.hWindow,true);
  (* DESACTIVATION DU SECOND BOUTON DE COMMANDE *)
  EnableWindow(BoutonCmd2^.hWindow,false);
  (* ACTIVATION DES BOUTONS DE CHOIX DES DES *)
  for i:=1 to 5 do
    begin
      EnableWindow(TabBoutonsDes[i]^.hWindow,true);
      LoadString(hInstance,st_TexteDeRelancer,c,9); TabBoutonsDes[i]^.SetCaption(c);
    end;
  (* TIRAGE DES CINQ DES *)
  for i:=1 to 5 do with TableauDes^[i] do
    begin
      repeat Montant:=Random(7) until Montant <> 0;
      Selection:=false;
    end;
  n:=GetMenuState(Parametres^.HandleMenu,cm_OptionsTri,mf_ByCommand or mf_Checked);
  if (n and mf_Checked) = mf_Checked then TRI_DES;
  for i:=1 to 5 do DESSIN_DE(i);
  (* INITIALISATION DES PARAMETRES DU COUP *)
  with Parametres^ do
    begin
      NbLancers:=2;
      ActionCourante:=ac_ChoixDes;
      DeCourant:=1;
      Ligne:=1; Colonne:=1;
    end;
  InvalidateRect(hWindow,nil,true);
  UpdateWindow(hWindow);
End;

Procedure tFenetreJeu.LANCER_DES (Tricher : Byte);
(* LANCER DES DES NON SELECTIONNES AVEC TRICHERIE EVENTUELLE *)
Var i : Byte;                  (* INDICE DANS LE TABLEAU DES DES *)
    MontantSelection : Byte;   (* INDICE DU 1ER DE SELECTIONNE (POUR FORCER UN YAHTZEE) *)
    Resultat : Word;           (* RESULTAT DU TEST DU COCHAGE DE L'OPTION DE TRI DANS LE MENU *)
Begin
  with Parametres^ do
    begin
      case Tricher of
        trich_Aucune : begin   (* LANCER SIMPLE DES DES *)
                         for i:=1 to 5 do with TableauDes^[i] do
                           if not Selection
                              then
                                begin
                                  repeat Montant:=Random(7) until Montant <> 0;
                                  DESSIN_DE(i);
                                end;
                       end;
        trich_Yahtzee : begin   (* FORCER UN YAHTZEE *)
                          (* RECHERCHE DU 1ER DE SELECTIONNE *)
                          i:=1; MontantSelection:=TableauDes^[1].Montant;
                          while i <= 5 do with TableauDes^[i] do
                            if Selection
                               then
                                 begin
                                   MontantSelection:=Montant;
                                   i:=6;   (* FIN DE BOUCLE *)
                                 end
                               else
                                 inc(i);
                          (* CREATION DU YAHTZEE "MIRACULEUX" *)
                          for i:=1 to 5 do with TableauDes^[i] do
                            if not Selection
                               then
                                 begin
                                   Montant:=MontantSelection;
                                   DESSIN_DE(i);
                                 end;
                        end;
        trich_GSuite : begin   (* FORCER UNE GRANDE SUITE *)
                       end;
      end;
      (* LE 1ER DE EST A NOUVEAU LE DE COURANT *)
      CONTOUR_BOUTON_DE(DeCourant);
      DeCourant:=1;
      CONTOUR_BOUTON_DE(1);
      (* MISE A JOUR DU NOMBRE DE LANCERS *)
      dec(NbLancers);
      AFFICHAGE_NOMBRE_LANCERS;
      if NbLancers = 0 then FIN_LANCER_DES;
    end;
End;

Procedure tFenetreJeu.FIN_LANCER_DES;
(* FIN DES LANCERS DE DES ET ACCES A LA FEUILLE DE POINTS *)
Var i : Byte;                    (* INDICE DANS LE TABLEAU DE DES *)
    n : Word;                    (* INDICE DE CHAINE DANS LA TABLE *)
    c : Array [0..14] of Char;   (* TEXTE DU BOUTON *)
Begin
  with Parametres^ do
    begin
      (* SELECTION DE TOUS LES DES *)
      for i:=1 to 5 do
        begin
          TableauDes^[i].Selection:=false;
          ACTIVATION_BOUTON_DE(i);
        end;
      (* EFFACEMENT DU CONTOUR AUTOUR DU DERNIER BOUTON DE CHOIX *)
      CONTOUR_BOUTON_DE(DeCourant);
      (* ACCES A LA FEUILLE DE POINTS *)
      ActionCourante:=ac_Inscription;
      CONTOUR_CASE_FEUILLE(1,1,true);
      (* TEXTE DU PREMIER BOUTON DE COMMANDE *)
      if HauteResolution then n:=st_TexteJoueurSuivantHR else n:=st_TexteJoueurSuivant;
      LoadString(hInstance,n,c,15);
      BoutonCmd1^.SetCaption(c);
      EnableWindow(BoutonCmd1^.hWindow,false);
      SetFocus(hWindow);
      (* DESACTIVATION DES BOUTONS DE CHOIX DES DES *)
      for i:=1 to 5 do EnableWindow(TabBoutonsDes[i]^.hWindow,false);
    end;
End;

Procedure tFenetreJeu.INSCRIPTION (l, c : Byte);
(* INSCRIPTION DES POINTS DANS LA CASE (l,c) DE LA FEUILLE DE POINTS *)
Var Convient : Boolean;    (* INDIQUE SI UNE CASE PEUT ETRE REMPLIE AVEC LE TIRAGE DE DES *)
    n : Byte;              (* INDICE DE BOUCLE *)
Begin
  with Joueurs^[IndexJoueur] do
    begin
      Convient:=false;
      case l of
        1..6 : begin   (* SECTION SUPERIEURE *)
                 if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                 FeuillePoints[l,c]:=0;
                 for n:=1 to 5 do if TableauDes^[n].Montant = l then Inc(FeuillePoints[l,c],l);
                 Inc(FeuillePoints[7,c],FeuillePoints[l,c]);
                 if FeuillePoints[7,c] >= 63 then Feuillepoints[8,c]:=35;
                 FeuillePoints[9,c]:=FeuillePoints[7,c] + FeuillePoints[8,c];
                 Convient:=true;
               end;
        10 : if (TEST_BRELAN) or (TEST_YAHTZEE)
                then
                  begin
                    if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                    FeuillePoints[l,c]:=0;
                    for n:=1 to 5 do Inc(FeuillePoints[l,c],TableauDes^[n].Montant);
                    Inc(FeuillePoints[17,c],FeuillePoints[l,c]);
                    Convient:=true;
                  end;
        11 : if (TEST_CARRE) or (TEST_YAHTZEE)
                then
                  begin
                    if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                    FeuillePoints[l,c]:=0;
                    for n:=1 to 5 do Inc(FeuillePoints[l,c],TableauDes^[n].Montant);
                    Inc(FeuillePoints[17,c],FeuillePoints[l,c]);
                    Convient:=true;
                  end;
        12 : if (TEST_FULL) or (TEST_YAHTZEE)
                then
                  begin
                    if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                    FeuillePoints[l,c]:=25;
                    Inc(FeuillePoints[17,c],FeuillePoints[l,c]);
                    Convient:=true;
                  end;
        13 : if TEST_PSUITE
                then
                  begin
                    FeuillePoints[l,c]:=30;
                    Inc(FeuillePoints[17,c],FeuillePoints[l,c]);
                    Convient:=true;
                  end;
        14 : if TEST_GSUITE
                then
                  begin
                    FeuillePoints[l,c]:=40;
                    Inc(FeuillePoints[17,c],FeuillePoints[l,c]);
                    Convient:=true;
                  end;
        15 : if TEST_YAHTZEE
                then
                  begin
                    Inc(FeuillePoints[19,2],c*100);
                    FeuillePoints[l,c]:=50;
                    Inc(FeuillePoints[17,c],FeuillePoints[l,c]);
                    Convient:=true;
                  end;
        16 : begin
               if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
               FeuillePoints[l,c]:=0;
               for n:=1 to 5 do Inc(FeuillePoints[l,c],TableauDes^[n].Montant);
               Inc(FeuillePoints[17,c],FeuillePoints[l,c]);
               Convient:=true;
             end;
      end;
      if Convient
         then   (* MISE A JOUR DES TOTAUX *)
           begin
             FeuillePoints[18,c]:=FeuillePoints[9,c] + FeuillePoints[17,c];
             FeuillePoints[19,1]:=FeuillePoints[18,1] + (FeuillePoints[18,2]*2) + (FeuillePoints[18,3]*3);
             Feuillepoints[19,3]:=FeuillePoints[19,1] + FeuillePoints[19,2];
           end
         else   (* LA CASE NE PEUT ETRE REMPLIE : METTRE UN ZERO *)
           begin
             FeuillePoints[l,c]:=0;
             MessageBeep($FFFF);   (* BIP SONORE *)
           end;
    end;
End;

Procedure tFenetreJeu.FIN_INSCRIPTION;
(* FIN DE L'INSCRIPTION SUR LA FEUILLE DE POINTS ET ACCES AUX BOUTONS DE COMMANDE *)
Begin
  with Parametres^ do
    begin
      (* EFFACEMENT DU CONTOUR AUOUR DE LA CASE DE LA FEUILLE DE POINTS *)
      CONTOUR_CASE_FEUILLE(Ligne,Colonne,false);
      (* ACCES AUX BOUTONS DE COMMANDE *)
      ActionCourante:=ac_Commande;
      CONTOUR_BOUTON_COMMANDE(1);
      (* REACTIVATION DES DEUX PREMIERS BOUTONS DE COMMANDE *)
      EnableWindow(BoutonCmd1^.hWindow,true);
      EnableWindow(BoutonCmd2^.hWindow,true);
    end;
End;

Function tFenetreJeu.TEST_YAHTZEE : Boolean;
(* TESTE SI LES CINQ DES FORMENT UN YAHTZEE *)
Begin
  TEST_YAHTZEE:=(TableauDes^[1].Montant = TableauDes^[2].Montant) and (TableauDes^[1].Montant = TableauDes^[3].Montant) and
                (TableauDes^[1].Montant = TableauDes^[4].Montant) and (TableauDes^[1].Montant = TableauDes^[5].Montant);
End;

Function tFenetreJeu.TEST_BRELAN : Boolean;
(* TESTE SI LES CINQ DES FORMENT UN BRELAN *)
Var m, n, Compteur : Byte;
Begin
  m:=0;
  repeat
    Inc(m);
    Compteur:=0;
    for n:=1 to 5 do if TableauDes^[n].Montant = m then Inc(Compteur);
  until (m = 6) or (Compteur >= 3);
  TEST_BRELAN:=(Compteur >= 3);
End;

Function tFenetreJeu.TEST_CARRE : Boolean;
(* TESTE SI LES CINQ DES FORMENT UN CARRE *)
Var m, n, Compteur : Byte;
Begin
  m:=0;
  repeat
    Inc(m);
    Compteur:=0;
    for n:=1 to 5 do if TableauDes^[n].Montant = m then Inc(Compteur);
  until (m = 6) or (Compteur >= 4);
  TEST_CARRE:=(Compteur >= 4);
End;

Function tFenetreJeu.TEST_FULL : Boolean;
(* TESTE SI LES CINQ DES FORMENT UN FULL *)
Var m, n, Triple, Compteur : Byte;
Begin
  TEST_FULL:=false;
  m:=0;
  repeat
    inc(m); Triple:=m;
    Compteur:=0;
    for n:=1 to 5 do if TableauDes^[n].Montant = m then Inc(Compteur);
  until (m = 6) or (Compteur = 3);
  if Compteur = 3
     then
       begin
         m:=0;
         repeat
           Inc(m);
           Compteur:=0;
           for n:=1 to 5 do if (m <> Triple) and (TableauDes^[n].Montant = m) then Inc(Compteur);
         until (m = 6) or (Compteur = 2);
         TEST_FULL:=(Compteur = 2);
       end;
End;

Function tFenetreJeu.TEST_PSUITE : Boolean;
(* TESTE SI LES CINQ DES FORMENT UNE PETITE SUITE *)
Var CopieTableauDes : tTabDes;   (* SAUVEGARDE DU TABLEAU DE DES NON TRIE *)
    m, n : Byte;                 (* INDICES DANS LE TABLEAU DE DES *)
    Sauve : Byte;                (* VARIABLE DE SAUVEGARDE TEMPORAIRE *)
    Erreur : Boolean;            (* INDIQUE SI LE TEST EST NEGATIF *)
Begin
  CopieTableauDes:=TableauDes^;
  TRI_DES;
  n:=1; Erreur:=false;
  repeat
    Inc(n);
    Sauve:=TableauDes^[n-1].Montant + 1;
    if TableauDes^[n].Montant <> Sauve
       then
         begin
           Erreur:=true; m:=n;
         end;
  until (n = 5) or (Erreur);
  if not Erreur
     then
       TEST_PSUITE:=true
     else
       begin
         Sauve:=TableauDes^[n].Montant;
         for n:=m to 4 do TableauDes^[n].Montant:=TableauDes^[n+1].Montant;
         TableauDes^[5].Montant:=Sauve;
         n:=1; Erreur:=false;
         repeat
           Inc(n);
           Sauve:=TableauDes^[n-1].Montant + 1;
           if TableauDes^[n].Montant <> Sauve then Erreur:=true;
         until (n = 4) or (Erreur);
         if not Erreur
            then
              TEST_PSUITE:=true
            else
              begin
                TRI_DES;
                n:=5; Erreur:=false;
                repeat
                  Dec(n);
                  Sauve:=TableauDes^[n+1].Montant - 1;
                  if TableauDes^[n].Montant <> Sauve then Erreur:=true;
                until (n = 2) or (Erreur);
                TEST_PSUITE:=not(Erreur);
              end;
       end;
  TableauDes^:=CopieTableauDes;
End;

Function tFenetreJeu.TEST_GSUITE : Boolean;
(* TESTE SI LES CINQ DES FORMENT UNE GRANDE SUITE *)
Var CopieTableauDes : tTabDes;
Begin
  CopieTableauDes:=TableauDes^;
  TRI_DES;
  TEST_GSUITE:=(TableauDes^[2].Montant = (TableauDes^[1].Montant + 1)) and
               (TableauDes^[3].Montant = (TableauDes^[2].Montant + 1)) and
               (TableauDes^[4].Montant = (TableauDes^[3].Montant + 1)) and
               (TableauDes^[5].Montant = (TableauDes^[4].Montant + 1));
  TableauDes^:=CopieTableauDes;
End;

Function tFenetreJeu.TEST_YAHTZEE_SUP : Boolean;
(* TESTE SI LES CINQ DES FORMENT UN YAHTZEE ET S'IL S'AGIT D'UN YAHTZEE SUPPLEMENTAIRE *)
Begin
  with Joueurs^[IndexJoueur] do TEST_YAHTZEE_SUP:=(TEST_YAHTZEE) and (FeuillePoints[15,1] = 50) and
                                                  (FeuillePoints[15,2] = 50) and (FeuillePoints[15,3] = 50);
End;

Procedure tFenetreJeu.IDBOUTONDE1 (var Msg : tMessage);
(* BOUTON DE SELECTION DU 1ER DE *)
Begin
  ACTIVATION_BOUTON_DE(1);
End;

Procedure tFenetreJeu.IDBOUTONDE2 (var Msg : tMessage);
(* BOUTON DE SELECTION DU 2EME DE *)
Begin
  ACTIVATION_BOUTON_DE(2);
End;

Procedure tFenetreJeu.IDBOUTONDE3 (var Msg : tMessage);
(* BOUTON DE SELECTION DU 3EME DE *)
Begin
  ACTIVATION_BOUTON_DE(3);
End;

Procedure tFenetreJeu.IDBOUTONDE4 (var Msg : tMessage);
(* BOUTON DE SELECTION DU 4EME DE *)
Begin
  ACTIVATION_BOUTON_DE(4);
End;

Procedure tFenetreJeu.IDBOUTONDE5 (var Msg : tMessage);
(* BOUTON DE SELECTION DU 5EME DE *)
Begin
  ACTIVATION_BOUTON_DE(5);
End;

Procedure tFenetreJeu.CMFLECHEHAUT (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DE LA FLECHE VERS LE HAUT *)
Begin
  with Parametres^ do
    case ActionCourante of
      ac_ChoixDes :
        begin
          CONTOUR_BOUTON_DE(DeCourant);
          if DeCourant = 1 then DeCourant:=5 else dec(DeCourant);
          CONTOUR_BOUTON_DE(DeCourant);
        end;
      ac_Inscription :
        begin
          CONTOUR_CASE_FEUILLE(Ligne,Colonne,false);
          if Ligne = 1 then Ligne:=PremiereLigneInf+6 else if Ligne = PremiereLigneInf then Ligne:=6 else dec(Ligne);
          CONTOUR_CASE_FEUILLE(Ligne,Colonne,true);
        end;
      ac_Commande :
        begin
          CONTOUR_BOUTON_COMMANDE(BoutonCommande);
          if BoutonCommande = 1 then BoutonCommande:=2 else Dec(BoutonCommande);
          CONTOUR_BOUTON_COMMANDE(BoutonCommande);
        end;
    end;
End;

Procedure tFenetreJeu.CMFLECHEBAS (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DE LA FLECHE VERS LE BAS *)
Begin
  with Parametres^ do
    case ActionCourante of
      ac_ChoixDes :
        begin
          CONTOUR_BOUTON_DE(DeCourant);
          if DeCourant = 5 then DeCourant:=1 else inc(DeCourant);
          CONTOUR_BOUTON_DE(DeCourant);
        end;
      ac_Inscription :
        begin
          CONTOUR_CASE_FEUILLE(Ligne,Colonne,false);
          if Ligne = (PremiereLigneInf+6) then Ligne:=1 else if Ligne = 6 then Ligne:=PremiereLigneInf else inc(Ligne);
          CONTOUR_CASE_FEUILLE(Ligne,Colonne,true);
        end;
      ac_Commande :
        begin
          CONTOUR_BOUTON_COMMANDE(BoutonCommande);
          if BoutonCommande = 2 then BoutonCommande:=1 else Inc(BoutonCommande);
          CONTOUR_BOUTON_COMMANDE(BoutonCommande);
        end;
    end;
End;

Procedure tFenetreJeu.CMFLECHEGAUCHE (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DE LA FLECHE VERS LA GAUCHE *)
Begin
  with Parametres^ do
    if ActionCourante = ac_Inscription
       then
         begin
           CONTOUR_CASE_FEUILLE(Ligne,Colonne,false);
           if Colonne = 1 then Colonne:=3 else dec(Colonne);
           CONTOUR_CASE_FEUILLE(Ligne,Colonne,true);
         end;
End;

Procedure tFenetreJeu.CMFLECHEDROITE (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DE LA FLECHE VERS LA DROITE *)
Begin
  with Parametres^ do
    if ActionCourante = ac_Inscription
       then
         begin
           CONTOUR_CASE_FEUILLE(Ligne,Colonne,false);
           if Colonne = 3 then Colonne:=1 else inc(Colonne);
           CONTOUR_CASE_FEUILLE(Ligne,Colonne,true);
         end;
End;

Procedure tFenetreJeu.CMENTER (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DE LA TOUCHE ENTER *)
Var LigneFeuille : Byte;   (* TRADUCTION DE LA LIGNE DE LA FEUILLE EN LIGNE DU TABLEAU *)
    Convient : Boolean;    (* INDIQUE SI UNE CASE PEUT ETRE REMPLIE AVEC LE TIRAGE DE DES *)
    n : Byte;              (* INDICE DE BOUCLE *)
Begin
  with Parametres^ do case ActionCourante of
    ac_ChoixDes : ACTIVATION_BOUTON_DE(DeCourant);
    ac_Inscription : with Joueurs^[IndexJoueur] do
      begin
        if (Ligne > 6) and not HauteResolution then LigneFeuille:=Ligne+2 else LigneFeuille:=Ligne;
        if FeuillePoints[LigneFeuille,Colonne] = $FFFF
           then   (* LA CASE EST LIBRE *)
             begin
               FeuillePointsSauve:=FeuillePoints;
               Convient:=false;
               case LigneFeuille of
                 1..6 : begin   (* SECTION SUPERIEURE *)
                          if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                          FeuillePoints[LigneFeuille,Colonne]:=0;
                          for n:=1 to 5 do
                            if TableauDes^[n].Montant = Ligne then Inc(FeuillePoints[LigneFeuille,Colonne],LigneFeuille);
                          Inc(FeuillePoints[7,Colonne],FeuillePoints[LigneFeuille,Colonne]);
                          if FeuillePoints[7,Colonne] >= 63 then Feuillepoints[8,Colonne]:=35;
                          FeuillePoints[9,Colonne]:=FeuillePoints[7,Colonne] + FeuillePoints[8,Colonne];
                          Convient:=true;
                        end;
                 10 : if (TEST_BRELAN) or (TEST_YAHTZEE)
                         then
                           begin
                             if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                             FeuillePoints[LigneFeuille,Colonne]:=0;
                             for n:=1 to 5 do Inc(FeuillePoints[LigneFeuille,Colonne],TableauDes^[n].Montant);
                             Inc(FeuillePoints[17,Colonne],FeuillePoints[LigneFeuille,Colonne]);
                             Convient:=true;
                           end;
                 11 : if (TEST_CARRE) or (TEST_YAHTZEE)
                         then
                           begin
                             if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                             FeuillePoints[LigneFeuille,Colonne]:=0;
                             for n:=1 to 5 do Inc(FeuillePoints[LigneFeuille,Colonne],TableauDes^[n].Montant);
                             Inc(FeuillePoints[17,Colonne],FeuillePoints[LigneFeuille,Colonne]);
                             Convient:=true;
                           end;
                 12 : if (TEST_FULL) or (TEST_YAHTZEE)
                         then
                           begin
                             if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                             FeuillePoints[LigneFeuille,Colonne]:=25;
                             Inc(FeuillePoints[17,Colonne],FeuillePoints[LigneFeuille,Colonne]);
                             Convient:=true;
                           end;
                 13 : if TEST_PSUITE
                         then
                           begin
                             FeuillePoints[LigneFeuille,Colonne]:=30;
                             Inc(FeuillePoints[17,Colonne],FeuillePoints[LigneFeuille,Colonne]);
                             Convient:=true;
                           end;
                 14 : if TEST_GSUITE
                         then
                           begin
                             FeuillePoints[LigneFeuille,Colonne]:=40;
                             Inc(FeuillePoints[17,Colonne],FeuillePoints[LigneFeuille,Colonne]);
                             Convient:=true;
                           end;
                 15 : if TEST_YAHTZEE
                         then
                           begin
                             Inc(FeuillePoints[19,2],Colonne*100);
                             FeuillePoints[LigneFeuille,Colonne]:=50;
                             Inc(FeuillePoints[17,Colonne],FeuillePoints[LigneFeuille,Colonne]);
                             Convient:=true;
                           end;
                 16 : begin
                        if TEST_YAHTZEE_SUP then Inc(FeuillePoints[19,2],300);
                        FeuillePoints[LigneFeuille,Colonne]:=0;
                        for n:=1 to 5 do Inc(FeuillePoints[LigneFeuille,Colonne],TableauDes^[n].Montant);
                        Inc(FeuillePoints[17,Colonne],FeuillePoints[LigneFeuille,Colonne]);
                        Convient:=true;
                      end;
               end;
               if Convient
                  then   (* MISE A JOUR DES TOTAUX *)
                    begin
                      FeuillePoints[18,Colonne]:=FeuillePoints[9,Colonne] + FeuillePoints[17,Colonne];
                      FeuillePoints[19,1]:=FeuillePoints[18,1] + (FeuillePoints[18,2]*2) + (FeuillePoints[18,3]*3);
                      Feuillepoints[19,3]:=FeuillePoints[19,1] + FeuillePoints[19,2];
                    end
                  else   (* LA CASE NE PEUT ETRE REMPLIE : METTRE UN ZERO *)
                    begin
                      FeuillePoints[LigneFeuille,Colonne]:=0;
                      MessageBeep($FFFF);   (* BIP SONORE *)
                    end;
               (* AFFICHAGE DU CONTENU DE LA CASE ET DES TOTAUX *)
               InvalidateRect(hWindow,@RectangleFeuille,true);
               UpdateWindow(hWindow);
               (* L'ACTION COURANTE DEVIENT LA SELECTION D'UNE COMMANDE *)
               FIN_INSCRIPTION;
             end;
      end;
    ac_Commande :
      begin
        case BoutonCommande of
          1 : IDBOUTONCMD1(Msg);
          2 : IDBOUTONCMD2(Msg);
        end;
      end;
  end;
End;

Procedure tFenetreJeu.CMESCAPE (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DE LA TOUCHE ESCAPE *)
Var i : Byte;   (* INDICE DANS LE TABLEAU DES DES *)
    n : Byte;   (* NOMBRE DE DES SELECTIONNES *)
Begin
  with Parametres^ do
    if ActionCourante = ac_ChoixDes
       then   (* NOUVEAU LANCER OU FIN DES LANCERS *)
         begin
           if NbLancers > 0
              then   (* NOUVEAU LANCER *)
                begin
                  (* TEST SI TOUS LES DES NE SONT PAS SELECTIONNES *)
                  n:=0; for i:=1 to 5 do if TableauDes^[i].Selection then inc(n);
                  if n < 5
                     then   (* IL Y A ENCORE DES DES A JOUER *)
                       LANCER_DES(trich_Aucune)
                     else   (* TOUS LES DES SONT SELECTIONNES : ACCES A LA FEUILLE DE POINTS *)
                       FIN_LANCER_DES;
                end
              else   (* FIN DES LANCERS : ACCES A LA FEUILLE DE POINTS *)
                FIN_LANCER_DES;
         end;
End;

Procedure tFenetreJeu.CMTRICHERYAHTZEE (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DE LA TOUCHE FORCANT UN TIRAGE DE YAHTZEE *)
Var i : Byte;   (* INDICE DANS LE TABLEAU DES DES *)
    n : Byte;   (* NOMBRE DE DES SELECTIONNES *)
Begin
  with Parametres^ do
    if ActionCourante = ac_ChoixDes
       then   (* NOUVEAU LANCER OU FIN DES LANCERS *)
         begin
           if NbLancers > 0
              then   (* NOUVEAU LANCER *)
                begin
                  (* TEST SI TOUS LES DES NE SONT PAS SELECTIONNES *)
                  n:=0; for i:=1 to 5 do if TableauDes^[i].Selection then inc(n);
                  if n < 5
                     then   (* IL Y A ENCORE DES DES A JOUER *)
                       LANCER_DES(trich_Yahtzee)
                     else   (* TOUS LES DES SONT SELECTIONNES : ACCES A LA FEUILLE DE POINTS *)
                       FIN_LANCER_DES;
                end
              else   (* FIN DES LANCERS : ACCES A LA FEUILLE DE POINTS *)
                FIN_LANCER_DES;
         end;
End;

Procedure tFenetreJeu.WMLBUTTONDOWN (var Msg : tMessage);
(* CLIC DU BOUTON GAUCHE DE LA SOURIS.
   - CHOIX DES DES : (DE)SELECTION D'UN DE;
   - FEUILLE DE POINTS : INSCRIPTION EVENTUELLE. *)
Var l, c : Byte;                 (* N DE DE OU DE LIGNE, N DE COLONNE *)
    i : Byte;                    (* INDICE DANS LE TABLEAU DES DES *)
    n : Word;                    (* INDICE DE CHAINE DANS LA TABLE *)
    a : Array [0..15] of Char;   (* TEXTE DU PREMIER BOUTON DE COMMANDE *)
          Function CURSEUR_SUR_DE (var n : Byte) : Boolean;
          (* RETOURNE LE N DU DE SUR LEQUEL L'UTILISATEUR A CLIQUE (0 SI AUCUN) *)
          Var i : Byte;   (* INDICE DE BOUCLE *)
          Begin
            n:=0; i:=1;
            while (i <= 5) do with Parametres^ do with TableauDes^[i] do with Msg do
              if (LParamLo >= xDe) and (LParamLo <= yDe) and (LParamHi >= y1D) and (LParamHi <= y2D)
                 then
                   begin
                     n:=i;
                     i:=6;   (* FIN DE BOUCLE *)
                   end
                 else
                   inc(i);
            CURSEUR_SUR_DE:=(n <> 0);
          End;
          Function CURSEUR_SUR_CASE (var l, c : Byte) : Boolean;
          (* RETOURNE LA LIGNE ET LA COLONNE DE LA CASE SUR LAQUELLE L'UTILISATEUR A CLIQUE (0 SI AUCUNE) *)
          Begin
            l:=0; c:=0;
            with Parametres^ do with Msg do
              if PtInRect(RectSectionSup,tPoint(LParam))
                 then with RectSectionSup do   (* CLIC DANS LA SECTION SUPERIEURE *)
                   begin
                     l:=((LParamHi-Top) div 20)+1;
                     c:=((LParamLo-Left) div 53)+1;
                   end
                 else
                   if PtInRect(RectSectionInf,tPoint(LParam))
                      then with RectSectionInf do   (* CLIC DANS LA SECTION INFERIEURE *)
                        begin
                          l:=((LParamHi-Top) div 20)+10;
                          c:=((LParamLo-Left) div 53)+1;
                        end;
            CURSEUR_SUR_CASE:=(l <> 0);
          End;
          Procedure MARQUAGE;
          (* MARQUAGE DES POINTS DANS LA FEUILLE ET ACCES AUX BOUTONS DE COMMADE *)
          Begin
            with Parametres^ do with Joueurs^[IndexJoueur] do
              begin
                (* MARQUAGE DES POINTS *)
                FeuillePointsSauve:=FeuillePoints;
                INSCRIPTION(l,c);
                (* REAFFICHAGE DE LA FEUILLE DE POINTS *)
                InvalidateRect(hWindow,@RectangleFeuille,true);
                UpdateWindow(hWindow);
                (* ACCES AUX BOUTONS DE COMMANDE *)
                CONTOUR_CASE_FEUILLE(Ligne,Colonne,false);
                (* ACCES AUX BOUTONS DE COMMANDE *)
                ActionCourante:=ac_Commande;
                CONTOUR_BOUTON_COMMANDE(1);
                (* TEXTE DU PREMIER BOUTON DE COMMANDE *)
                if HauteResolution then n:=st_TexteJoueurSuivantHR else n:=st_TexteJoueurSuivant;
                LoadString(hInstance,n,a,15);
                BoutonCmd1^.SetCaption(a);
                EnableWindow(BoutonCmd1^.hWindow,true);
                (* REACTIVATION DU SECOND BOUTON DE COMMANDE *)
                EnableWindow(BoutonCmd2^.hWindow,true);
                SetFocus(hWindow);
              end;
          End;

Begin
  with Parametres^ do
    if CURSEUR_SUR_DE(l)
       then   (* L'UTILISATEUR A CLIQUE SUR UN DE *)
         begin
           if ActionCourante = ac_ChoixDes then ACTIVATION_BOUTON_DE(l);
         end
       else with Joueurs^[IndexJoueur] do
         if CURSEUR_SUR_CASE(l,c) and (Feuillepoints[l,c] = $FFFF)
            then   (* L'UTILISATEUR A CLIQUE SUR UNE CASE DE LA FEUILLE DE POINTS VIERGE *)
              if ActionCourante = ac_ChoixDes
                 then   (* SELECTION DE TOUS LES DES ET MARQUAGE DES POINTS DANS LA FEUILLE *)
                   begin
                     (* SELECTION DE TOUS LES DES *)
                     for i:=1 to 5 do
                       begin
                         TableauDes^[i].Selection:=false;
                         ACTIVATION_BOUTON_DE(i);
                       end;
                     (* DESACTIVATION DES BOUTONS DE CHOIX DES DES *)
                     for i:=1 to 5 do EnableWindow(TabBoutonsDes[i]^.hWindow,false);
                     MARQUAGE;
                   end
                 else
                   if ActionCourante = ac_Inscription
                      then   (* MARQUAGE IMMEDIAT DES POINTS DANS LA FEUILLE *)
                        MARQUAGE;
End;

Function tFenetreJeu.JOUEUR_SUIVANT : Byte;
(* RETOURNE L'INDICE DU JOUEUR SUIVANT (0 S'IL N'Y EN A PLUS) *)
Var i : Byte;              (* INDICE DANS LE TABLEAU DES JOUEURS *)
    JoueurTrouve : Byte;   (* INDICE DU JOUEUR SUIVANT *)
Begin
  JoueurTrouve:=0;
  if IndexJoueur < 10
     then   (* RECHERCHE DANS LES INDICES SUPERIEURS *)
       begin
         i:=IndexJoueur+1;
         while (i <= 10) do
           if Joueurs^[i].FenetreMDI <> nil
              then   (* UN JOUEUR A ETE TROUVE *)
                begin
                  JoueurTrouve:=i;
                  i:=11;
                end
              else
                inc(i);
       end;
  if JoueurTrouve = 0
     then   (* RECHERCHE DANS LES INDICES INFERIEURS *)
       begin
         i:=1;
         while (i <= IndexJoueur) do
           if Joueurs^[i].FenetreMDI <> nil
              then   (* UN JOUEUR A ETE TROUVE *)
                begin
                  JoueurTrouve:=i;
                  i:=11;
                end
              else
                inc(i);
       end;
  if (JoueurTrouve <> 0) and (Joueurs^[JoueurTrouve].CoupsJoues = 39)
     then   (* LE SEUL QUI RESTE EST LE JOUEUR COURANT ET IL A TERMINE LA PARTIE *)
       JoueurTrouve:=0;
  JOUEUR_SUIVANT:=JoueurTrouve;
End;

Procedure tFenetreJeu.IDBOUTONCMD1 (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DU BOUTON DE COMMANDE "LANCER LES DES" / "JOUEUR SUIVANT" *)
Var JoueurSuivant : Byte;   (* INDICE DU JOUEUR SUIVANT *)
    i : Byte;               (* INDICE DANS LE TABLEAU DES DES *)
    n : Byte;               (* NOMBRE DE DES SELECTIONNES *)
Begin
  with Parametres^ do
    case ActionCourante of
      ac_ChoixDes :   (* RELANCER LES DES *)
        begin
          if NbLancers > 0
             then   (* NOUVEAU LANCER *)
               begin
                 (* TEST SI TOUS LES DES NE SONT PAS SELECTIONNES *)
                 n:=0; for i:=1 to 5 do if TableauDes^[i].Selection then inc(n);
                 if n < 5
                    then   (* IL Y A ENCORE DES DES A JOUER *)
                      LANCER_DES(trich_Aucune)
                    else   (* TOUS LES DES SONT SELECTIONNES : ACCES A LA FEUILLE DE POINTS *)
                      FIN_LANCER_DES;
               end
             else   (* FIN DES LANCERS : ACCES A LA FEUILLE DE POINTS *)
               FIN_LANCER_DES;
        end;
      ac_Commande :   (* PASSER AU JOUEUR SUIVANT *)
        begin
          with Joueurs^[IndexJoueur] do
            begin
              Inc(CoupsJoues);
              if CoupsJoues = 39 then CloseWindow;
            end;
          (* PASSAGE AU JOUEUR SUIVANT *)
          JoueurSuivant:=JOUEUR_SUIVANT;
          if JoueurSuivant = 0
             then   (* C'ETAIT LE DERNIER COUP DU DERNIER JOUEUR : FIN DE LA PARTIE ET CLASSEMENT *)
               PostMessage(Parent^.hWindow,wm_Command,cm_Enregistrer,0)
             else
               if JoueurSuivant = IndexJoueur
                  then   (* LE JOUEUR COURANT EST LE SEUL JOUEUR EN LICE *)
                    PREPARATION_PREMIER_LANCER_DES
                  else with Joueurs^[JoueurSuivant] do  (* PASSAGE DU FLAMBEAU AU SUIVANT *)
                    begin
                      FenetreMDI^.PREPARATION_PREMIER_LANCER_DES;
                      SetFocus(FenetreMDI^.hWindow);
                    end;
        end;
    end;
End;

Procedure tFenetreJeu.IDBOUTONCMD2 (var Msg : tMessage);
(* REPONSE A L'ACTIVATION DU BOUTON DE COMMANDE "CORRIGER LES POINTS" *)
Begin
  with Parametres^ do
    if ActionCourante = ac_Commande
       then
         begin
           CONTOUR_BOUTON_COMMANDE(BoutonCommande);
           Joueurs^[IndexJoueur].FeuillePoints:=FeuillePointsSauve;
           Ligne:=1; Colonne:=1;
           BoutonCommande:=1;
           ActionCourante:=ac_Inscription;
           InvalidateRect(hWindow,nil,true);
           UpdateWindow(hWindow);
           (* DESACTIVATION DU BOUTON DE COMMANDE *)
           EnableWindow(BoutonCmd2^.hWindow,false);
         end;
End;

Procedure tFenetreJeu.WMSYSCOMMAND (var Msg : tMessage);
(* INTERCEPTION DE TOUTES LES COMMANDES SYSTEME *)
Var Message : Array [0..75] of Char;   (* TEXTE DE LA BOITE MESSAGE *)
    Titre : Array [0..25] of Char;     (* TITRE DE LA BOITE MESSAGE *)
    JoueurSuivant : Byte;              (* INDICE DU JOUEUR SUIVANT *)
Begin
  case Msg.wParam of
    sc_Close : begin   (* CONFIRMATION D'ABANDON *)
                 LoadString(hInstance,st_TexteAbandonner,Message,SizeOf(Message));
                 LoadString(hInstance,st_TitreAbandonner,Titre,SizeOf(Titre));
                 if MessageBox(hWindow,Message,Titre,mb_YesNo or mb_IconQuestion) = id_Yes
                    then   (* PASSAGE AU JOUEUR SUIVANT AVANT DE FERMER LA FENETRE *)
                      begin
                        (* PASSAGE AU JOUEUR SUIVANT *)
                        JoueurSuivant:=JOUEUR_SUIVANT;
                        if JoueurSuivant = 0
                           then   (* C'ETAIT LE DERNIER COUP DU DERNIER JOUEUR : FIN DE LA PARTIE ET CLASSEMENT *)
                             PostMessage(Parent^.hWindow,wm_Command,cm_Enregistrer,0)
                           else
                             if JoueurSuivant = IndexJoueur
                                then   (* LE JOUEUR COURANT EST LE SEUL JOUEUR EN LICE *)
                                  PREPARATION_PREMIER_LANCER_DES
                                else with Joueurs^[JoueurSuivant] do  (* PASSAGE DU FLAMBEAU AU SUIVANT *)
                                  begin
                                    FenetreMDI^.PREPARATION_PREMIER_LANCER_DES;
                                    SetFocus(FenetreMDI^.hWindow);
                                  end;
                        tWindow.WMSYSCOMMAND(Msg);
                      end;
               end;
  else
    tWindow.WMSYSCOMMAND(Msg);
  end;
End;

Destructor tFenetreJeu.DONE;
(* ANNULATION DE L'ADRESSE DE LA FENETRE DANS LA LISTE DES JOUEURS *)
Begin
  Joueurs^[IndexJoueur].FenetreMDI:=nil;
  tWindow.DONE;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                         METHODES DE L'OBJET tDlgNomsJoueurs                                          *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgNomsJoueurs.SETUPWINDOW;
(* INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;                    (* COORDONNEES DE LA FENETRE *)
    Largeur, Hauteur : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    i : Byte;                     (* INDICE DANS LE TABLEAU DE JOUEURS *)
Begin
  tDialog.SETUPWINDOW;
  (* CENTRAGE DU DIALOGUE A L'ECRAN *)
  GetWindowRect(hWindow,r);
  with r do
    begin
      Largeur:=Right-Left;
      Hauteur:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-Largeur) div 2,(GetSystemMetrics(sm_CYScreen)-Hauteur) div 2,
             Largeur,Hauteur,true);
  (* INITIALISATION DES CONTROLES ENFANTS *)
  for i:=1 to 10 do with Joueurs^[i] do
    begin
      SendDlgItemMessage(hWindow,id_NomJoueur1+i-1,em_LimitText,20,0);
      SendDlgItemMessage(hWindow,id_NomJoueur1+i-1,wm_SetText,0,LongInt(@NomJoueur));
    end;
End;

Procedure tDlgNomsJoueurs.OK (var Msg : tMessage);
(* BOUTON "OK" : LES NOMS DES JOUEURS SONT CHARGES DANS LE TABLEAU *)
Var i : Byte;   (* INDICE DANS LE TABLEAU DES JOUEURS *)
Begin
  for i:=1 to 10 do with Joueurs^[i] do SendDlgItemMessage(hWindow,id_NomJoueur1+i-1,wm_GetText,21,LongInt(@NomJoueur));
  tDialog.OK(Msg);
End;

Procedure tDlgNomsJoueurs.HELP (var Msg : tMessage);
(* ACCES A L'AIDE *)
Var c : Array [0..12] of Char;   (* NOM DU FICHIER HLP *)
Begin
  LoadString(hInstance,st_NomFichierAide,c,SizeOf(c));
  WinHelp(hWindow,c,help_Index,0);
End;

Procedure tDlgNomsJoueurs.CANCEL (var Msg : tMessage);
(* BOUTON "QUITTER" : FIN DU JEU (TABLEAU DES JOUEURS VIDE) *)
Var i : Byte;   (* INDICE DANS LE TABLEAU DES JOUEURS *)
Begin
  for i:=1 to 10 do Joueurs^[i].NomJoueur[0]:=#0;
  tDialog.Cancel(Msg);
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                          METHODES DE L'OBJET tDlgResultats                                           *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgResultats.SETUPWINDOW;
(* INITIALISATION DES DEUX LISTES DE CLASSEMENT *)
Var r : tRect;                               (* COORDONNEES DE LA FENETRE *)
    Largeur, Hauteur : Integer;              (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    i : Byte;                                (* INDICE DANS LE CLASSEMENT *)
    s : String [5];                          (* CONVERSION DE NOMBRE EN CHAINE *)
    c : Array [0..5] of Char;                (* NOMBRE A AFFICHER *)
Begin
  tDialog.SETUPWINDOW;
  (* CENTRAGE DU DIALOGUE A L'ECRAN *)
  GetWindowRect(hWindow,r);
  with r do
    begin
      Largeur:=Right-Left;
      Hauteur:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-Largeur) div 2,(GetSystemMetrics(sm_CYScreen)-Hauteur) div 2,
             Largeur,Hauteur,true);
  (* INITIALISATION DES CONTROLES ENFANTS *)
  for i:=1 to 10 do with Joueurs^[i] do
    if StrLen(NomJoueur) > 0
       then
         begin
           SendDlgItemMessage(hWindow,id_NomJoueur1+i-1,wm_SetText,0,LongInt(@NomJoueur));
           Str(FeuillePoints[19,1],s); StrPCopy(c,s); SendDlgItemMessage(hWindow,id_Brut1+i-1,wm_SetText,0,LongInt(@c));
           Str(FeuillePoints[19,2],s); StrPCopy(c,s); SendDlgItemMessage(hWindow,id_Prime1+i-1,wm_SetText,0,LongInt(@c));
           Str(FeuillePoints[19,3],s); StrPCopy(c,s); SendDlgItemMessage(hWindow,id_Total1+i-1,wm_SetText,0,LongInt(@c));
         end;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                         METHODES DE L'OBJET tDlgClassements                                          *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgClassements.SETUPWINDOW;
(* INITIALISATION DES DEUX LISTES DE CLASSEMENT *)
Var r : tRect;                               (* COORDONNEES DE LA FENETRE *)
    Largeur, Hauteur : Integer;              (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    i : Byte;                                (* INDICE DANS LE CLASSEMENT *)
    s : String [42];                         (* VARIABLE TEMPORAIRE DE CONSTRUCTION DE ChaineListe *)
    Nb : String [3];                         (* CONVERSION DE NOMBRES EN CHAINES *)
    ChaineListe : Array [0..42] of Char;     (* CHAINE A AJOUTER DANS LA LISTE *)
    Tabulations : Array [1..3] of Integer;   (* LARGEUR DES TROIS TABULATIONS DES LISTES *)
Begin
  tDialog.SETUPWINDOW;
  (* CENTRAGE DU DIALOGUE A L'ECRAN *)
  GetWindowRect(hWindow,r);
  with r do
    begin
      Largeur:=Right-Left;
      Hauteur:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-Largeur) div 2,(GetSystemMetrics(sm_CYScreen)-Hauteur) div 2,
             Largeur,Hauteur,true);
  (* INITIALISATION DES MARQUES DE TABULATION DES LISTES *)
  Tabulations[1]:=12; Tabulations[2]:=70; Tabulations[3]:=200;
  SendDlgItemMessage(hWindow,id_Classement1,lb_SetTabStops,3,LongInt(@Tabulations));
  SendDlgItemMessage(hWindow,id_Classement2,lb_SetTabStops,3,LongInt(@Tabulations));
  (* CHARGEMENT DU CLASSEMENT SANS PRIMES YAHTZEE *)
  i:=1;
  while i <= 100 do
    if Classement1^[i][1] <> ' '
       then
         begin
           (* CONSTRUCTION DE LA CHAINE *)
           Str(i,Nb);
           s:=StrPas(Classement1^[i]);
           StrPCopy(ChaineListe,Nb+#9+Copy(s,11,10)+#9+Copy(s,21,20)+#9+Copy(s,1,5));
           (* AJOUT DE LA CHAINE DANS LA LISTE *)
           SendDlgItemMessage(hWindow,id_Classement1,lb_AddString,0,LongInt(@ChaineListe));
           inc(i);
         end
       else   (* CHAINE VIERGE : FIN DE BOUCLE *)
         i:=101;
  (* CHARGEMENT DU CLASSEMENT AVEC PRIMES YAHTZEE *)
  i:=1;
  while i <= 100 do
    if Classement2^[i][1] <> ' '
       then
         begin
           (* CONSTRUCTION DE LA CHAINE *)
           Str(i,Nb);
           s:=StrPas(Classement2^[i]);
           StrPCopy(ChaineListe,Nb+#9+Copy(s,11,10)+#9+Copy(s,21,20)+#9+Copy(s,6,5));
           (* AJOUT DE LA CHAINE DANS LA LISTE *)
           SendDlgItemMessage(hWindow,id_Classement2,lb_AddString,0,LongInt(@ChaineListe));
           inc(i);
         end
       else   (* CHAINE VIERGE : FIN DE BOUCLE *)
         i:=101;
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                           METHODES DE L'OBJET tDlgConversion                                         *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgConversion.SETUPWINDOW;
(* INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;                    (* COORDONNEES DE LA FENETRE *)
    Largeur, Hauteur : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    i : Byte;                     (* INDICE DANS LE TABLEAU DE JOUEURS *)
Begin
  tDialog.SETUPWINDOW;
  (* CENTRAGE DU DIALOGUE A L'ECRAN *)
  GetWindowRect(hWindow,r);
  with r do
    begin
      Largeur:=Right-Left;
      Hauteur:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-Largeur) div 2,(GetSystemMetrics(sm_CYScreen)-Hauteur) div 2,
             Largeur,Hauteur,true);
  (* INITIALISATION DES CONTROLES ENFANTS *)
  SendDlgItemMessage(hWindow,id_Source1,em_LimitText,255,0);
  SendDlgItemMessage(hWindow,id_Source2,em_LimitText,255,0);
End;

Procedure tDlgConversion.OK (var Msg : tMessage);
(* BOUTON "OK" : LECTURE DES NOMS DE FICHIERS *)
Begin
  with Parametres^ do
    begin
      Source1[0]:=#0; Source2[0]:=#0;
      SendDlgItemMessage(hWindow,id_Source1,wm_GetText,256,LongInt(@Source1));
      SendDlgItemMessage(hWindow,id_Source2,wm_GetText,256,LongInt(@Source2));
    end;
  tDialog.OK(Msg);
End;

Procedure tDlgConversion.HELP (var Msg : tMessage);
(* ACCES A L'AIDE *)
Var c : Array [0..12] of Char;   (* NOM DU FICHIER HLP *)
Begin
  LoadString(hInstance,st_NomFichierAide,c,SizeOf(c));
  WinHelp(hWindow,c,help_Index,0);
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                            METHODES DE L'OBJET tDlgFusion                                            *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgFusion.SETUPWINDOW;
(* INITIALISATION DES CONTROLES ENFANTS *)
Var r : tRect;                    (* COORDONNEES DE LA FENETRE *)
    Largeur, Hauteur : Integer;   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    i : Byte;                     (* INDICE DANS LE TABLEAU DE JOUEURS *)
Begin
  tDialog.SETUPWINDOW;
  (* CENTRAGE DU DIALOGUE A L'ECRAN *)
  GetWindowRect(hWindow,r);
  with r do
    begin
      Largeur:=Right-Left;
      Hauteur:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-Largeur) div 2,(GetSystemMetrics(sm_CYScreen)-Hauteur) div 2,
             Largeur,Hauteur,true);
  (* INITIALISATION DES CONTROLES ENFANTS *)
  SendDlgItemMessage(hWindow,id_Source1,em_LimitText,255,0);
  SendDlgItemMessage(hWindow,id_Dest1,em_LimitText,255,0);
  SendDlgItemMessage(hWindow,id_Source2,em_LimitText,255,0);
  SendDlgItemMessage(hWindow,id_Dest2,em_LimitText,255,0);
End;

Procedure tDlgFusion.OK (var Msg : tMessage);
(* BOUTON "OK" : LECTURE DES NOMS DE FICHIERS *)
Begin
  with Parametres^ do
    begin
      Source1[0]:=#0; Dest1[0]:=#0; Source2[0]:=#0; Dest2[0]:=#0;
      SendDlgItemMessage(hWindow,id_Source1,wm_GetText,256,LongInt(@Source1));
      SendDlgItemMessage(hWindow,id_Dest1,wm_GetText,256,LongInt(@Dest1));
      SendDlgItemMessage(hWindow,id_Source2,wm_GetText,256,LongInt(@Source2));
      SendDlgItemMessage(hWindow,id_Dest2,wm_GetText,256,LongInt(@Dest2));
      EviterRedondance:=(SendDlgItemMessage(hWindow,id_OptionFusion,bm_GetCheck,0,0) = 1);
    end;
  tDialog.OK(Msg);
End;

Procedure tDlgFusion.HELP (var Msg : tMessage);
(* ACCES A L'AIDE *)
Var c : Array [0..12] of Char;   (* NOM DU FICHIER HLP *)
Begin
  LoadString(hInstance,st_NomFichierAide,c,SizeOf(c));
  WinHelp(hWindow,c,help_Index,0);
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                           METHODES DE L'OBJET tDlgAPropos                                            *)
(* -------------------------------------------------------------------------------------------------------------------- *)

Procedure tDlgAPropos.SETUPWINDOW;
(* CENTRAGE DU DIALOGUE A L'ECRAN *)
Var r : tRect;                               (* COORDONNEES DE LA FENETRE *)
    Largeur, Hauteur : Integer;              (* LARGEUR ET HAUTEUR DE LA FENETRE *)
Begin
  tDialog.SETUPWINDOW;
  (* CENTRAGE DU DIALOGUE A L'ECRAN *)
  GetWindowRect(hWindow,r);
  with r do
    begin
      Largeur:=Right-Left;
      Hauteur:=Bottom-Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen)-Largeur) div 2,(GetSystemMetrics(sm_CYScreen)-Hauteur) div 2,
             Largeur,Hauteur,true);
End;

(* -------------------------------------------------------------------------------------------------------------------- *)
(*                                                PROGRAMME PRINCIPAL                                                   *)
(* -------------------------------------------------------------------------------------------------------------------- *)

BEGIN
  Programme.INIT('Triple Yahtzee 3.00');
  Programme.RUN;
  Programme.DONE;
END.
